
JSB.newAddon = function (mainPath) {

  JSB.require('webviewController');
  JSB.require('notificationController')
  JSB.require('utils')
  /** @return {MNChatglmClass} */
  const getMNChatglmClass = ()=>self  
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNChatglm_config")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNChatglm_promptNames")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_currentPrompt');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_toolbar');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_onNewExcerpt');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_dynamic');

  let defaultPrompts = {
      Translate:                      {title: "翻译",context:"请翻译下面这段话：{{context}}"},
      Keyword:                        {title: "关键词",context:"请为下面这段话提取关键词：{{context}}"},
      Title:                          {title: "标题",context:"请为下面这段话生成标题：{{context}}"}
  }
  let defaultConfig = {
    searchOrder: [2,1,3],
    autoAction: false,
    onSelection: true,
    onNote: true,
    onNewExcerpt: true,
    onWebMode: false,
    notifyLoc: 0,
    toolbar: true,
    model: 0,
    promptNames: Object.keys(defaultPrompts),
    currentPrompt: Object.keys(defaultPrompts)[0],
    apikey: "",
    modelOnReAsk: -1
  }
  let prompts = getLocalDataByKeyDefault('MNChatglm_prompts',defaultPrompts)
  let knowledge = getLocalDataByKeyDefault('MNChatglm_knowledge',"")
  let config = getLocalDataByKeyDefault('MNChatglm_config',defaultConfig)
  let currentPrompt = config.currentPrompt
  let onNewExcerpt = config.onNewExcerpt
  let toolbar = config.toolbar
  // var temSender;
  // showHUD("knowledge"+knowledge)

  var MNChatglmClass = JSB.defineClass(
    'MNChatglm : JSExtension',
    { /* Instance members */
      sceneWillConnect: function () { //Window initialize
        self.isNewWindow = false;
        self.watchMode = false;
        self.textSelected = ""
        self.textProcessed = false;
        self.dateGetText = Date.now();
        self.dateNow = Date.now();
        self.rect = '{{0, 0}, {10, 10}}';
        self.arrow = 1;
        self.isFirst = true;
        self.linkDetected = false
      },

      sceneDidDisconnect: function () { // Window disconnect

      },

      sceneWillResignActive: function () { // Window resign active
      },

      sceneDidBecomeActive: function () { // Window become active
      },

      notebookWillOpen: function (notebookid) {
        self.appInstance = Application.sharedInstance();
        self.studyController = Application.sharedInstance().studyController(self.window)
        // self.addonController = browserController.new();
        if (!self.addonController) {
          self.addonController = chatglmController.new();
        }

          // showHUD("loc"+self.addonController.notifyLoc)
        self.addonController.mainPath = mainPath;
        self.addonController.config = config
        self.addonController.prompts = prompts;
        self.addonController.knowledge = knowledge
          // showHUD("knowledge"+self.addonController.knowledge)
        if (!self.notifyController) {
          self.notifyController = notificationController.new();
          self.notifyController.mainPath = mainPath;
          self.notifyController.config = self.addonController.config
          self.studyController.view.addSubview(self.notifyController.view);
          self.notifyController.view.hidden = true
          self.notifyController.view.frame = {x:50,y:50,width:400,height:120}
          self.notifyController.currentFrame = {x:50,y:50,width:400,height:120}
          self.notifyController.addonController = self.addonController
          // self.notifyController.show(0)
        }

        self.studyController.view.addSubview(self.addonController.view);
        self.studyController.refreshAddonCommands();
        self.addonController.view.hidden = true;
        self.addonController.notebookid = notebookid
        self.addonController.webview.loadRequest(
          NSURLRequest.requestWithURL(NSURL.URLWithString(self.addonController.homePageURL))
        );
        addObserver(self, 'onPopupMenuOnSelection:', 'PopupMenuOnSelection')
        addObserver(self, 'onPopupMenuOnNote:', 'PopupMenuOnNote')
        addObserver(self, 'onClosePopupMenuOnNote:', 'ClosePopupMenuOnNote')
        addObserver(self, 'onProcessNewExcerpt:', 'ProcessNewExcerpt')
        addObserver(self, 'onChatOnNote:', 'chatOnNote')
        addObserver(self, 'onChatOnQuestion:', 'chatOnQuestion')
        // addObserver(self, 'shownotify:', 'UITextViewTextDidBeginEditingNotification')

        



        const modelNames = ["Lite","Std","Pro"]
          // showHUD(self.promptNames)
        if (self.addonController.promptNames.includes(config.currentPrompt)) {
          self.addonController.currentPrompt = currentPrompt
          self.addonController.engineButton.setTitleForState(prompts[config.currentPrompt].title, 0);
        }
        if (toolbar !== undefined) {
          self.addonController.toolbarOn = toolbar
          self.addonController.homeButton.hidden = !toolbar
          self.addonController.engineButton.hidden = !toolbar
          var viewFrame = self.addonController.view.bounds;
          if (self.addonController.toolbarOn) {
            self.addonController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height - 40 }
          } else {
            self.addonController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height }
          }
        }
        NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
          self.appInstance.studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
        });
      },
      // shownotify: function (params) {
      //   showHUD("123")
      // },
      notebookWillClose: function (notebookid) {
        // Application.sharedInstance().showHUD("close",self.window,2)
        // self.addonController.homePage()
        self.addonController.view.removeFromSuperview()
        // self.appInstance.studyController(self.window).view.remov(self.addonController.view);
        
        self.watchMode = false;
        self.textSelected = '';
        if (self.notifyController.connection) {
          self.notifyController.connection.cancel()
          delete self.notifyController.connection
        }
        removeObservers(self,['PopupMenuOnSelection','ClosePopupMenuOnSelection','PopupMenuOnNote','ClosePopupMenuOnNote'])
      },

      documentDidOpen: function (docmd5) {
      },

      documentWillClose: function (docmd5) {
      },

      controllerWillLayoutSubviews: function (controller) {
        if (controller !== self.appInstance.studyController(self.window)) {
          return;
        };
        // self.appInstance.showHUD('test',self.window,2)
        if (!self.addonController.view.hidden) {
          let studyFrame = Application.sharedInstance().studyController(self.window).view.bounds
          if (self.addonController.miniMode) {
            let oldFrame = self.addonController.view.frame
            if (oldFrame.x < studyFrame.width*0.5) {
            // self.addonController.view.frame = self.addonController.currentFrame
              self.addonController.view.frame = { x: 0, y: oldFrame.y, width: 40, height: 40 }
            } else {
              self.addonController.view.frame = { x: studyFrame.width - 40, y: oldFrame.y, width: 40, height: 40 }
            }
          } else if (self.addonController.custom) {
            self.addonController.setSplitScreenFrame(self.addonController.customMode)
            self.addonController.webview.frame = self.addonController.view.bounds
          }else{
            let currentFrame = self.addonController.currentFrame
            if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
              currentFrame.x = studyFrame.width-currentFrame.width*0.5              
            }
            if (currentFrame.y >= studyFrame.height) {
              currentFrame.y = studyFrame.height-20              
            }
            self.addonController.view.frame = currentFrame
            self.addonController.currentFrame = currentFrame
          }
        }
        if (!self.notifyController.view.hidden) {
          let currentFrame = self.notifyController.currentFrame
          self.notifyController.view.frame = currentFrame
          
        }
      },

      queryAddonCommandStatus: function () {
        return {
          image: 'logo.png',
          object: self,
          selector: 'toggleAddon:',
          checked: self.addonController.config.autoAction
        };
      },

      onPopupMenuOnSelection: function (sender) { // Selecting text on pdf or epub
        let self = getMNChatglmClass()
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        self.textSelected = sender.userInfo.documentController.selectionText;
        self.addonController.selectedText = self.textSelected
        self.dateGetText = Date.now();
        self.textProcessed = false
        if (!self.addonController.view.hidden && !self.addonController.config.onWebMode) {
          //网页模式下不会使用API模式
          return
        }
        if (!self.addonController.view.window || !self.addonController.config.autoAction || !self.addonController.config.onSelection) return;
        self.notifyController.noteid = undefined
        self.notifyController.text = self.textSelected
        self.notifyController.currentPrompt = self.addonController.config.currentPrompt
        let question = self.addonController.getQuestion(self.textSelected)
        // let config = self.addonController.config
        self.notifyController.ask(question)
        // self.beginNotification()
        if (self.viewTimer) self.viewTimer.invalidate();
      },
      onProcessNewExcerpt: function (sender) {
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
      try {
        

        let note = Database.sharedInstance().getNoteById(sender.userInfo.noteid)
        let currentNoteId = note.noteId
        self.notShow = false
        self.noteid = currentNoteId
        if (note.excerptPic) {
          return
        }

        let text = self.getTextForSearch(note)
        if (self.addonController.config.ignoreShortText && countWords(text) < 10) {
          return
        }
        self.textSelected = text
        // self.textSelected = encodeURIComponent(note.excerptText ?? note.noteTitle.replaceAll('/', '\\/'))
        self.addonController.selectedText = self.textSelected
        self.addonController.currentNoteId = currentNoteId
        self.dateGetText = Date.now();
        self.textProcessed = false
        temSender = sender
        // Application.sharedInstance().showHUD(sender.userInfo.note,self.window,2)
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!self.addonController.view.window || !self.addonController.config.autoAction || !self.addonController.config.onNewExcerpt) return;
        if (self.notifyController.onChat) {
          return
        }
        if (!self.addonController.view.hidden && !self.addonController.config.onWebMode) {
          //网页模式下不会使用API模式
          return
        }
        if (!self.addonController.config.colorConfig[note.colorIndex]) {
          // showHUD("should prevent")
          return
        }
        self.notifyController.noteid = currentNoteId
        self.notifyController.text = text
        self.notifyController.currentPrompt = self.addonController.config.currentPrompt
        let question = self.addonController.getQuestion(text)
        // let config = self.addonController.config
        self.notifyController.query = text
        self.notifyController.ask(question)
        // self.beginNotification()
      } catch (error) {
        showHUD(error)
      }
      },
      onPopupMenuOnNote: function (sender) { // Clicking note
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
      try {
        
        self.notifyController.notShow = false
        let note = sender.userInfo.note
        let currentNoteId = note.noteId
        self.noteid = currentNoteId
        let text = self.getTextForSearch(note)
        if (!text) {
          return
        }
        if (self.addonController.config.ignoreShortText && countWords(text) < 10) {
          return
        }
        self.textSelected = text
        // self.textSelected = encodeURIComponent(note.excerptText ?? note.noteTitle.replaceAll('/', '\\/'))
        self.addonController.selectedText = self.textSelected
        self.addonController.currentNoteId = currentNoteId
        self.dateGetText = Date.now();
        self.textProcessed = false
        temSender = sender
        // Application.sharedInstance().showHUD(sender.userInfo.note,self.window,2)
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!self.addonController.view.window || !self.addonController.config.autoAction || !self.addonController.config.onNote) {
          return;
        }
        if (self.notifyController.onChat) {
          return
        }
        if (!self.addonController.view.hidden && !self.addonController.config.onWebMode) {
          //网页模式下不会使用API模式
          return
        }
        if (!self.addonController.config.colorConfig[note.colorIndex+16]) {
          // showHUD("should prevent")
          return
        }
        // self.currentTime = Date.now()
        self.notifyController.noteid = sender.userInfo.note.noteId
        self.notifyController.text = text
        self.notifyController.currentPrompt = self.addonController.config.currentPrompt
        let question = self.addonController.getQuestion(text)
        if (!self.notifyController.view.hidden && self.lastQuestion == question) {
          // showHUD("same question")
          return
        }
        self.lastQuestion = question
        self.notifyController.query = text
        // let config = self.addonController.config
        // showHUD("model:"+config.model)
        // self.notifyController.textviewResponse.text = "I'm thinking..."
        self.notifyController.ask(question)
        // self.notifyController.notifyLoc = self.addonController.notifyLoc

          // showHUD("delay:"+(Date.now()-self.currentTime))
        // self.beginNotification()
      } catch (error) {
        showHUD(error)
      }
      },
      onClosePopupMenuOnNote: function (sender) {
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
          // showHUD("delay:"+(Date.now()-self.currentTime))
        if (self.noteid === sender.userInfo.noteid && Date.now()-self.dateGetText < 500) {
          self.notifyController.notShow = true
        }
      },
      onChatOnNote: function (sender) { // Clicking note
        if (self.window!==self.appInstance.focusWindow) {
          return
        }
      try {
        // showHUD("teset")
        self.notifyController.notShow = false
        self.notifyController.called = true
        let note = getNoteById(sender.userInfo.noteid)
        let currentNoteId = note.noteId
        self.noteid = currentNoteId
        let text = self.getTextForSearch(note)
        if (!text) {
          return
        }
        self.textSelected = text
        // self.textSelected = encodeURIComponent(note.excerptText ?? note.noteTitle.replaceAll('/', '\\/'))
        self.addonController.selectedText = self.textSelected
        self.addonController.currentNoteId = currentNoteId
        self.dateGetText = Date.now();
        self.textProcessed = false
        temSender = sender
        // Application.sharedInstance().showHUD(sender.userInfo.note,self.window,2)
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!self.addonController.view.window) return;
        // self.currentTime = Date.now()
        self.notifyController.noteid = note.noteId
        self.notifyController.text = text
        self.notifyController.currentPrompt = self.addonController.config.currentPrompt
        let question = self.addonController.getQuestion(text)
        // self.notifyController.textviewResponse.text = "I'm thinking..."
        self.notifyController.ask(question)
        self.notifyController.notifyLoc = self.addonController.notifyLoc

          // showHUD("delay:"+(Date.now()-self.currentTime))
        // self.beginNotification()
      } catch (error) {
        showHUD(error)
      }
      },
      onChatOnQuestion: function (sender) { // Clicking note
        if (self.window!==self.appInstance.focusWindow) {
          return
        }
      try {
        // showHUD("teset")
        let self = getMNChatglmClass()
        self.notifyController.notShow = false
        self.notifyController.called = true
        let currentNoteId = undefined
        self.noteid = currentNoteId
        let question = sender.userInfo.question
        // self.textSelected = encodeURIComponent(note.excerptText ?? note.noteTitle.replaceAll('/', '\\/'))
        self.addonController.selectedText = self.textSelected
        self.addonController.currentNoteId = currentNoteId
        self.dateGetText = Date.now();
        self.textProcessed = false
        temSender = sender
        // Application.sharedInstance().showHUD(sender.userInfo.note,self.window,2)
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!self.addonController.view.window) return;
        // self.currentTime = Date.now()
        self.notifyController.noteid = undefined
        if (sender.userInfo.model) {
          self.addonController.config.currentModel = sender.userInfo.model
        }else{
          self.addonController.config.currentModel = self.addonController.config.model
        }
        if (/{{knowledge}}/.test(question)) {
          let knowledge = self.addonController.knowledge
          if (knowledge && knowledge.trim() != "") {
            question = question.replace('{{knowledge}}',`
以及部分参考翻译
'''
${knowledge}
'''`)
          }else{
            question = question.replace('{{knowledge}}',``)
          }
        }
        // self.notifyController.textviewResponse.text = "I'm thinking..."
        self.notifyController.ask(question)
        self.notifyController.notifyLoc = self.addonController.notifyLoc
          // showHUD("delay:"+(Date.now()-self.currentTime))
        // self.beginNotification()
      } catch (error) {
        showHUD(error)
      }
      },
      toggleAddon: function (sender) {
        if (!self.addonBar) {
          self.addonBar = sender.superview.superview
          self.addonController.addonBar = self.addonBar
        }
        if (self.addonController.view.hidden) {
          if (self.isFirst) {
            // Application.sharedInstance().showHUD("first",self.window,2)
            let buttonFrame = self.addonBar.frame
            let width = 375
            if (buttonFrame.x === 0) {
              self.addonController.view.frame = {x:40,y:buttonFrame.y,width:width,height:550}
            }else{
              self.addonController.view.frame = {x:buttonFrame.x-width,y:buttonFrame.y,width:width,height:550}
            }
            self.addonController.currentFrame = self.addonController.view.frame
            self.isFirst = false;
          }
          self.addonController.show(self.addonBar.frame)
          if (!self.notifyController.view.hidden) {
            self.notifyController.hide()
            self.notifyController.notifyTimer.invalidate()
          }
          // self.addonController.view.hidden = false
          // self.addonController.webview.hidden = false
        } else {
            // self.addonController.view.hidden = true;
          if (self.addonController.miniMode) {
            let preFrame = self.addonController.view.frame
            self.addonController.view.hidden = true
            self.addonController.showAllButton()
            let studyFrame = Application.sharedInstance().studyController(self.window).view.bounds
            if (self.addonController.view.frame.x < studyFrame.width*0.5) {
              self.addonController.lastFrame.x = 0
            }else{
              self.addonController.lastFrame.x = studyFrame.width-self.addonController.lastFrame.width
            }
            self.addonController.view.frame  = self.addonController.lastFrame
            self.addonController.currentFrame = self.addonController.lastFrame
            self.addonController.show(preFrame)
          }else{
            self.addonController.hide(self.addonBar.frame)
          }
          self.watchMode = false;
          self.appInstance.studyController(self.window).refreshAddonCommands();
          return;
        }
        NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
          self.appInstance.studyController(self.window).becomeFirstResponder(); // For dismiss keyboard on iOS
        });

        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
      },
    },
    { /* Class members */
      addonDidConnect: function () {
      },

      addonWillDisconnect: function () {
        NSUserDefaults.standardUserDefaults().removeObjectForKey("MNChatglm_prompts")
        NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_knowledge');
        NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_config');

      },

      applicationWillEnterForeground: function () {
      },

      applicationDidEnterBackground: function () {
      },

      applicationDidReceiveLocalNotification: function (notify) {
      }
    }
  );

  MNChatglmClass.prototype.layoutAddonController = function (rectStr, arrowNum) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (this.appInstance.osType !== 1) ? 419 : 365, // this.addonController.view.frame.width
      h = 500, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
    // this.appInstance.showHUD('x:'+x+';y:'+Y,this.window,2)
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y, width: w, height: h };

  };
  MNChatglmClass.prototype.customLayoutAddonController = function (rectStr, arrowNum, custom = false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
      w = (this.appInstance.osType !== 1) ? 419 : 365, // this.addonController.view.frame.width
      h = 450, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y + 50, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y + 50 , width: w, height: h };
  };
  MNChatglmClass.prototype.checkWatchMode = function () {
    if (Date.now() - this.dateNow < 500) {
      this.watchMode = true;
      Application.sharedInstance().showHUD("Watch mode", this.window, 2)
      this.appInstance.studyController(this.window).refreshAddonCommands();
      this.addonController.webview.hidden = false
      this.addonController.view.hidden = false
      this.addonController.showAllButton()

      // if (this.addonController.view.hidden) {
      //   this.addonController.show(this.addonBar.frame)
      // }
      return true;
    }else{
      this.dateNow = Date.now()
      return false
    }
  };
  MNChatglmClass.prototype.getNoteList = function (note) {
    let noteList = []
    if (note.noteTitle) {
      noteList.push(note.noteTitle)
    }
    if (note.excerptText && !note.excerptPic) {
      noteList.push(note.excerptText)
    }
    return noteList.concat(note.comments.filter(comment=>comment.type="TextNote").map(comment=>comment.text))
  };
  MNChatglmClass.prototype.getTextForSearch = function (note) {
    let order = this.addonController.config.searchOrder
    // showHUD(order)
    let text
    for (let index = 0; index < order.length; index++) {
      const element = order[index];
      switch (element) {
        case 1:
          if (note.noteTitle && note.noteTitle !== "") {
            text = note.noteTitle
          }
          break;
        case 2:
          if (note.excerptText && note.excerptText !== "" && (!note.excerptPic || note.textFirst)) {
            text = note.excerptText
          }
          break;
        case 3:
          let commentText
          let comment = note.comments.find(comment=>{
            switch (comment.type) {
              case "TextNote":
                if (/^marginnote3app:\/\//.test(comment.text)) {
                  return false
                }else{
                  commentText = comment.text
                  return true
                }
              case "HtmlNote":
                commentText = comment.text
                return true
              case "LinkNote":
                if (comment.q_hpic && !note.textFirst) {
                  return false
                }else{
                  commentText = comment.q_htext
                  return true
                }
              default:
                return false
            }
          })
          // let noteText  = note.comments.filter(comment=>comment.type === "TextNote" && !/^marginnote3app:\/\//.test(comment.text))
          // if (noteText.length) {
          //   text =  noteText[0].text
          // }
          if (commentText && commentText.length) {
            // showHUD("comment")
            text = commentText
          }
          break;
        default:
          break;
      }
      if (text) {
        // showHUD(text)
        return text
      }
    }
  // showHUD("No text found")
  return ""
  }
  MNChatglmClass.prototype.beginNotification = function () {
    this.notifyController.notifyLoc = this.addonController.notifyLoc
    // let notifyController = this.notifyController
    // notifyController.textviewResponse.text = "I'm thinking..."
    // // showHUD("loc:"+notifyLoc)
    // if (notifyController.view.hidden || notifyController.notifyLoc !== notifyLoc) {
    //   notifyController.show(notifyLoc)
    // }
    // this.appInstance.studyController(this.window).view.bringSubviewToFront(notifyController.view)
    // if (notifyController.notifyTimer) {
    //   notifyController.notifyTimer.invalidate()
    // }
    // notifyController.notifyTimer = NSTimer.scheduledTimerWithTimeInterval(10, false, function () {
    //   notifyController.hide(notifyLoc)
    //   notifyController.notifyTimer.invalidate()
    // })
  }
  return MNChatglmClass;
};

