// type XOR<T, U> = T | U extends object
//   ? (Without<T, U> & U) | (Without<U, T> & T)
//   : T | U
// type Without<T, U> = { [P in Exclude<keyof T, keyof U>]?: never }

class Response {
  data
  constructor(data) {
    this.data = data
  }
  json() {
    if (this.data.length() === 0) return {}
    const res = NSJSONSerialization.JSONObjectWithDataOptions(
      this.data,
      1<<0
    )
    if (NSJSONSerialization.isValidJSONObject(res)) return res
    throw lang.not_JSON
  }
  /**
   * @deprecated not supported, always return empty string
   */
  text() {
    if (this.data.length() === 0) return ""
    return ""
  }
}
function genNSURL(url) {
  return NSURL.URLWithString(url)
}

function getAuthorization(apikey) {
  let header = JSON.stringify({"alg":"HS256","sign_type":"SIGN"})

  let payload =JSON.stringify({
    "api_key": apikey.split(".")[0],
    "exp": Date.now()+60000,
    "timestamp": Date.now()
  });
  let secretSalt = apikey.split(".")[1];
  let before_sign = base64UrlEncode(CryptoJS.enc.Utf8.parse(header)) + '.' + base64UrlEncode(CryptoJS.enc.Utf8.parse(payload));

  let  signature =CryptoJS.HmacSHA256(before_sign, secretSalt);
   signature = base64UrlEncode(signature);
  
  let final_sign = before_sign + '.' + signature;
  return final_sign
}

//和普通base64加密不一样
function base64UrlEncode(str) {
   var encodedSource = CryptoJS.enc.Base64.stringify(str);
   var reg = new RegExp('/', 'g');
   encodedSource = encodedSource.replace(/=+$/,'').replace(/\+/g,'-').replace(reg,'_');
   return encodedSource;
}