JSB.require('utils');
JSB.require('CryptoJS')
JSB.require('network')
// JSB.require('base64')
/** @return {notificationController} */
const getNotificationController = ()=>self


var notificationController = JSB.defineClass('notificationController : UIViewController <NSURLConnectionDelegate>', {
  viewDidLoad: function() {
    let self = getNotificationController()
    self.init()
    self.appInstance = Application.sharedInstance();
    self.custom = false;
    self.customMode = "None"
    // Application.sharedInstance().showHUD("process:0",Application.sharedInstance().focusWindow,5)
    self.dynamic = true;
    self.miniMode = false;
    self.shouldCopy = false
    self.shouldComment = false
    self.selectedText = '';
    self.searchedText = '';
    self.engine = 'Bing'
    self.isLoading = false;
    self.toolbarOn = true;
    self.view.frame = {x:50,y:50,width:(self.appInstance.osType !== 1) ? 419 : 365,height:120}
    self.lastFrame = self.view.frame;
    // self.currentFrame = self.view.frame
    self.history = []
    self.isMainWindow = true
    self.title = "main"
    self.test = [0]
    self.moveDate = Date.now()
    self.notifyLoc = self.config.notifyLoc
    self.color = [true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true]
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.cornerRadius = 11
    self.view.layer.opacity = 1.0
    self.view.layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
    self.view.layer.borderWidth = 0
    self.view.backgroundColor = hexColorAlpha("#ffffff",0)

    self.highlightColor = UIColor.blendedColor( hexColorAlpha("#2c4d81",0.8),
      self.appInstance.defaultTextColor,
      0.8
    );

    self.notificationView = UIView.new()
    self.notificationView.layer.cornerRadius = 8
    self.notificationView.backgroundColor = hexColorAlpha("#ffffff",0.0)
    self.view.addSubview(self.notificationView)
    self.notiScroll = UIScrollView.new()
    self.notiScroll.layer.cornerRadius = 8
    self.notiScroll.backgroundColor = hexColorAlpha("#ffffff",0.0)
    self.notiScroll.scrollEnabled = true

    self.notificationView.addSubview(self.notiScroll)

    // self.creatTextView("textviewResponse","notiScroll")
    self.textviewResponse = UITextView.new()
    self.textviewResponse.font = UIFont.systemFontOfSize(16);
    self.textviewResponse.layer.cornerRadius = 8
    self.textviewResponse.backgroundColor = hexColorAlpha("#ffffff",0.8)
    self.textviewResponse.textColor = UIColor.blackColor()
    self.textviewResponse.delegate = self
    self.textviewResponse.contentSize = {width:400,height:120}
    self.textviewResponse.scrollEnabled = false
    self.textviewResponse.text = `Loading...`
    // self.textviewResponse.bounces = false
    self.notiScroll.addSubview(self.textviewResponse)

    self.createButton("toolbar",undefined,"notificationView")
    self.toolbar.backgroundColor = hexColorAlpha("#727f94",0.0)

    // self.createButton("screenButton","changeScreen:","toolbar")
    self.createButton("screenButton","closeButtonTapped:","toolbar")
    self.screenButton.setImageForState(self.stopImage,0)
    self.screenButton.backgroundColor = hexColorAlpha("#e06c75",0.8)

    self.createButton("bigbangButton","bigbang:","toolbar")
    self.bigbangButton.setImageForState(self.bigbangImage,0)

    self.createButton("copyButton","copy:","toolbar")
    self.copyButton.setImageForState(self.copyImage,0)

    self.createButton("titleButton","setNoteTitle:","toolbar")
    self.titleButton.setImageForState(self.titleImage,0)

    self.createButton("commentButton","setComment:","toolbar")
    self.commentButton.setImageForState(self.commentImage,0)

    self.createButton("promptButton","changePrompts:","toolbar")
    self.promptButton.setTitleForState("关键词",0)
    self.promptButton.titleLabel.font = UIFont.boldSystemFontOfSize(16);

    self.createButton("locationButton","toggleLocation:","toolbar")
    self.locationButton.setTitleForState(self.config.notifyLoc?' R ':' L ',0)
    // self.locationButton.setTitleForState(" R ")
    self.locationButton.titleLabel.font = UIFont.boldSystemFontOfSize(20);

    self.createButton("aiLinkButton","showAILink:","toolbar")
    self.aiLinkButton.setImageForState(self.aiLinkImage,0)

    self.createButton("reloadButton","reAsk:","toolbar")
    self.reloadButton.setImageForState(self.reloadImage,0)

    self.createButton("chatButton","openChatView:","toolbar")
    self.chatButton.setImageForState(self.chatImage,0)

    self.createButton("aiButton")
    self.aiButton.setImageForState(self.aiImage,0)
    self.aiButton.backgroundColor = hexColorAlpha("#ffffff",0.8)

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")


  },
  viewWillAppear: function(animated) {
  },
  viewWillDisappear: function(animated) {
  },
  viewWillLayoutSubviews: function() {
  let self = getNotificationController()
    // Application.sharedInstance().showHUD("test", self.view.window, 2);
    // Application.sharedInstance().showHUD("process:5",Application.sharedInstance().focusWindow,5)

    let buttonHeight = 30
    // self.view.frame = self.currentFrame
    var viewFrame = self.view.frame;
    var height   = viewFrame.height

    if (self.onChat) {
      // let studyFrame = studyController().view.frame
      // viewFrame.height = studyFrame.height-50
      // self.view.frame = viewFrame
      // self.currentFrame = viewFrame
      // viewFrame.x = 0
      // viewFrame.y = 0
      // self.chatView.frame = viewFrame
      // self.setChatLayout()
    }else{
      viewFrame.x = 0
      viewFrame.y = 0
      self.notificationView.frame = viewFrame;
      viewFrame.width = 400
      viewFrame.height = height-35
      self.notiScroll.frame = viewFrame

      viewFrame.height = self.textviewResponse.sizeThatFits({width:400,height:1000}).height
      if (viewFrame.height<120) {
        viewFrame.height = 120
      }
      self.textviewResponse.frame = viewFrame
      // showHUD("contentHeight:"+viewFrame.height+";viewHeight:"+self.textviewResponse.frame.height)
      self.toolbar.frame = genFrame(0, height-30, 400,buttonHeight)
      self.setLayout()
    }

  },
  closeButtonTapped:async function (params) {
    let self = getNotificationController()
    if (self.connection) {
      self.connection.cancel()
      delete self.connection
    }
    await self.hide()
    self.onChat = false
    self.chatView.hidden = true
    self.notificationView.hidden = false
    self.textviewResponse.frame = genFrame(0, 0, 400, 120)

  },
  bigbang:function () {
    // showHUD("noteid"+self.noteid)
    let text = self.getTextForAction()
    if (!self.noteid) {
      postNotification("bigbangText",{text:text})
    }else{
      postNotification("bigbangText",{text:text,noteid:self.noteid,url:"marginnote3app://note/"+self.noteid})
    }
  },
  copy: function () {
    let text = self.getTextForAction()
    UIPasteboard.generalPasteboard().string = text
    showHUD("文字已复制")
  },
  // textViewDidBeginEditing:function (textview) {
  //   self.notifyTimer.invalidate()
  // },
  reAsk:function (params) {
    let self = getNotificationController()
    // self.textviewResponse.text = "I'm rethinking..."
    try {
      
    if (self.notifyTimer) {
      self.notifyTimer.invalidate()
    }
    self.notShow = false
    self.called = true
    self.ask(self.question,1.0)
    } catch (error) {
      showHUD(error)
    }
  },
  setNoteTitle: function() {
    if (!self.noteid) {
      showHUD("Unavailable")
    }
    // try {
      
    let text = self.getTextForAction()
    let note = getNoteById(self.noteid)
    undoGroupingWithRefresh(self.notebookid,()=>{
      // if (note.noteTitle) {
      //   note.noteTitle = note.noteTitle+"; "+self.textviewResponse.text.trim()
      // }else{
        note.noteTitle = text.trim()
      // }
    })
    // }catch (error) {
    //   showHUD(error)
    // }
  },
  setComment: function () {
    if (!self.noteid) {
      showHUD("Unavailable")
    }
    let text = self.getTextForAction()
    let note = getNoteById(self.noteid)
    undoGroupingWithRefresh(self.notebookid,()=>{
      note.appendTextComment(text.trim())
    })
  },
  showAILink: function () {
    if (!self.noteid) {
      showHUD("Unavailable")
    }
    let text = self.getTextForAction()
    postNotification("aiLinkOnText",{text:text,noteid:self.noteid})
  },
  changePrompts: function(sender) {
    let self = getNotificationController();
    self.promptButton.setTitleForState(self.addonController.prompts[self.currentPrompt].title ,0)
    var commandTable = self.config.promptNames.map(promptName => {
      return {title:self.addonController.prompts[promptName].title,object:self,selector:'askWithPrompt:',param:promptName,checked:self.config.currentPrompt===promptName}
    })
    self.view.popoverController = getPopoverAndPresent(sender,commandTable,200)
  },
  askWithPrompt: function (prompt) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    try {
    let self = getNotificationController();
    let question = self.addonController.getQuestion(self.text,prompt)
    self.ask(question)
    self.currentPrompt = prompt
    self.promptButton.setTitleForState(self.addonController.prompts[prompt].title ,0)
      
    } catch (error) {
      showHUD(error)
    }
  },
  onResizeGesture:function (gesture) {
    if (self.notifyTimer) {self.notifyTimer.invalidate()}
    if (self.notifyLoc === 0) {
      self.custom = false;
      self.dynamic = false;
      self.customMode = "none"
      let baseframe = gesture.view.frame
      let locationToBrowser = gesture.locationInView(self.view)
      let frame = self.view.frame
      let height = locationToBrowser.y+baseframe.height*0.5
      if (height <= 100) {
        height = 100
      }
      //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
      //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
      self.view.frame = {x:50,y:50,width:400,height:height}
      self.currentFrame  = self.view.frame
    }else{
      self.custom = false;
      self.dynamic = false;
      self.customMode = "none"
      let baseframe = gesture.view.frame
      let locationToBrowser = gesture.locationInView(self.view)
      let frame = self.view.frame
      let height = locationToBrowser.y+baseframe.height*0.5
      if (height <= 120) {
        height = 120
      }
      //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
      //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
      self.view.frame = {x:frame.x,y:50,width:400,height:height}
      self.currentFrame  = self.view.frame
    }

  },
  toggleLocation:function (params) {
    let self = getNotificationController()
    // showHUD("show:"+self.addonController.config.notifyLoc)
    try {
    switch (self.addonController.config.notifyLoc) {
      case 1:
        self.addonController.config.notifyLoc = 0
        if (self.onChat) {
          self.chatLocation.setTitleForState("Left",0)
          self.setChatLayout()
        }else{
          self.locationButton.setTitleForState(" L ",0)
        }
        if (self.addonController.windowLocationButton) {
          self.addonController.windowLocationButton.setTitleForState("Notification: Left",0)
        }
        break;
      case 0:
        self.addonController.config.notifyLoc = 1
        if (self.onChat) {
          self.chatLocation.setTitleForState("Right",0)
          self.setChatLayout()
        }else{
          self.locationButton.setTitleForState(" R ",0)
        }
        if (self.addonController.windowLocationButton) {
          self.addonController.windowLocationButton.setTitleForState("Notification: Right",0)
        }
        // self.locationButton.setTitleForState(" R ",0)
        break;
      default:
        break;
    }
    self.show(self.addonController.config.notifyLoc)
    
    // self.notifyController.config = self.config
    setLocalDataByKey(self.addonController.config,'MNChatglm_config')
    } catch (error) {
      showHUD(error)
    }
  },
  openChatView: function (params) {
    let self = getNotificationController()
    if (self.connection) {
      showHUD("Wait...")
      return
    }
    try {
      

    self.round = 0
    if (self.notifyTimer) {
      self.notifyTimer.invalidate()
    }
    self.notificationView.hidden = true
    self.onChat = true
    // self.openChatView()
    self.chatView = new UIView(self.view.bounds)
    self.chatView.layer.cornerRadius = 8
    self.chatView.backgroundColor = hexColorAlpha("#ffffff",0.0)
    self.view.addSubview(self.chatView)
    self.chatToolbar = UIView.new()
    self.chatToolbar.layer.cornerRadius = 8
    self.chatToolbar.backgroundColor = hexColorAlpha("#ffffff",0.0)
    self.chatView.addSubview(self.chatToolbar)
    self.createButton("closeChatButton","closeButtonTapped:","chatToolbar")
    self.closeChatButton.setImageForState(self.stopImage,0)
    self.closeChatButton.backgroundColor = hexColorAlpha("#e06c75",0.8)
    self.createButton("sendButton","continueAsk:","chatView")
    self.sendButton.setImageForState(self.sendImage,0)
    self.sendButton.backgroundColor = hexColorAlpha("#e06c75",0.8)
    self.creatTextView("userInput","chatView")
    self.userInput.editable = true
    self.userInput.layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
    self.createButton("chatLocation","toggleLocation:","chatToolbar")
    self.chatLocation.setTitleForState(self.config.notifyLoc?'Right':'Left',0)
    self.chatLocation.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    self.createButton("chatToken","doNothing:","chatToolbar")
    self.chatToken.setTitleForState(self.token[0]+"("+sum(self.token)+")",0)
    self.chatToken.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    self.scrollView = UIScrollView.new()
    self.scrollView.layer.cornerRadius = 8
    self.scrollView.backgroundColor = hexColorAlpha("#ffffff",0.8)
    self.chatView.addSubview(self.scrollView)
    self.creatTextView("assistant0","scrollView")
    self.assistant0.text = self.textviewResponse.text
    self.assistant0.layer.borderColor = hexColorAlpha("#ffffff",0.8)
    var viewFrame = self.view.frame;
    var height   = viewFrame.height
    let studyFrame = studyController().view.frame
    viewFrame.height = studyFrame.height-50
    self.view.frame = viewFrame
    self.currentFrame = viewFrame
    self.chatView.frame = genFrame(0, 0, viewFrame.width, viewFrame.height)
    self.setChatLayout()
    } catch (error) {
      showHUD(error)
    }
  },
  continueAsk: function (params) {
    let self = getNotificationController()
    if (self.connection) {
      showHUD("Wait...")
      return
    }
    self.round = self.round+1
    try {
      
    let text = self.userInput.text
    self.userInput.text = ""
    self.creatTextView("user"+self.round,"scrollView")
    self["user"+self.round].text = text
    self["user"+self.round].layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
    self["user"+self.round].backgroundColor = hexColorAlpha("#9bb2d6",0.2)
    self.creatTextView("assistant"+self.round,"scrollView")
    self["assistant"+self.round].text = "I'm thinking..."
    self["assistant"+self.round].layer.borderColor = hexColorAlpha("#ffffff",0.8)
    self.targetTextview = "assistant"+self.round
    self.setChatLayout()
    self.continueAsk(text)
    } catch (error) {
      showHUD(error)
    }
    // showHUD("continue")
  },
  textViewDidBeginEditing:function (textview) {
    // showHUD("begin")
    self.notifyTimer.invalidate()
  },
  connectionDidReceiveResponse: function (connection,response) {
    // let res = new Response(response)
    // showHUD(JSON.stringify(res))
    // const res = NSJSONSerialization.JSONObjectWithDataOptions(
    //   response,
    //   1<<0
    // )
    // NSJSONSerialization.isValidJSONObject(res)
    // showHUD(response.textEncodingName())
    self.response = ""
    // showHUD("delay:"+Date.now()-self.currentTime)
    // if (self.notShow && !self.called) {
    //   // showHUD("not")
    //   connection.cancel()
    //   delete self.connection
    //   return
    // }
    self.notShow = false
    self.size = []
    self.preHeight = 0
    self.autoHide = true
    if (self.onChat) {
      self.setChatLayout()
      // return
    }else{
      self.setNotiLayout()
    }
    // let currentFrame = self.view.frame
    // currentFrame.height = 120
    // self.view.frame = currentFrame
    // self.beginNotification()
    // self.allText = ""
  },
  connectionDidReceiveData: function (connection,data) {
    let self = getNotificationController()
  let test = CryptoJS.enc.Base64.parse(data.base64Encoding())
  self.textString = CryptoJS.enc.Utf8.stringify(test);
  // showHUD("length:"+items.length)
  // copy(textString)
  var checkMessageNumber = self.textString.split("event:add")
  let messageBumber = checkMessageNumber.length
  if (messageBumber>=2) {
    var items = checkMessageNumber[messageBumber-1].split("\n")
    let data
    if (items.length !== 5) {
      let dataItems = items.filter(item=>/data:/.test(item))
      // showHUD(dataItems)
      data = dataItems.map(item=>item.split("data:")[1]).join("\n")
    }else{
      data = items[2].split("data:")[1]
    }
    // self.response = self.response+data
    // self.allText = self.allText+textString
    let diff = data.length - self[self.targetTextview].text.length
    if (diff > 30 || diff < 0) {
      return
    }
    self[self.targetTextview].text = data.trim()//self.response.trim().replaceAll("   ","\n").replaceAll("  "," ")
    // self[self.targetTextview].scrollRectToVisibleAnimated(genFrame(0, size.height-currentFrame.height, 400, currentFrame.height-30),false)
  }else{
    return
  }
  if (self.onChat) {
    self.setChatLayout()
    // return
  }else{
    self.setNotiLayout()
  }
  return
  },
  connectionDidFinishLoading: function (connection) {
    let self = getNotificationController()
  if (/event\:interrupted/.test(self.textString)) {
    let data = self.textString.split("data:").at(-1)
    showHUD(data)
    self.finish()
    return;
  }
  try {
    let tokens = self.textString.split(`event:finish`)[1].split(`"total_tokens":`)
    let token = tokens[1].split("}")[0]
    var items = self.textString.split(`event:finish`)[1].split("\n")
    self.token.push(Number(token))
    if (self.onChat) {
      self.chatToken.setTitleForState(""+token+" ("+sum(self.token)+")",0)
    }else{
      self.promptButton.setTitleForState(token,0)
    }
    let data
    if (items.length !== 5) {
      let dataItems = items.filter(item=>/data:/.test(item))
      // showHUD(dataItems)
      data = dataItems.map(item=>item.split("data:")[1]).join("\n")
    }else{
      data = items[2].split("data:")[1]
    }
    self[self.targetTextview].text = data.trim()//self.response.trim().replaceAll("   ","\n").replaceAll("  "," ")
  } catch (error) {
    // copy(self.textString)
    let tokens = self.textString.split(`"total_tokens":`)
    let token = tokens[1].split("}")[0]
    self.token.push(Number(token))
    if (self.onChat) {
      // self.chatLocation.setTitleForState(token,0)
      self.chatToken.setTitleForState(""+token+" ("+sum(self.token)+")",0)
    }else{
      self.promptButton.setTitleForState(token,0)
    }
  }
  try {
    
  if (self.onChat) {
    self.setChatLayout()
  }else{
    self.setNotiLayout()
  }
    self.finish()
  } catch (error) {
    showHUD(error)
  }
    // UIPasteboard.generalPasteboard().string = self.allText
  },
  connectionDidFailWithError: function (connection,error) {
    // showHUD("error")
  }
});

/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.ask = function(question,temperature=0.8,reask=false) {
  // Application.sharedInstance().showHUD(url, this.view.window, 2);
  // this.engineButton.setTitleForState(this.prompts[this.currentPrompt].title, 0);
  // showHUD("delay:"+this.config.delay)
  this.history = []
  this.token = []
  this.targetTextview = "textviewResponse"
  let config = this.addonController.config
  /**
   * @type {notificationController}
   */
  let controller = this
  let delay = config.delay
  if (controller.called) {
    delay = 0
  }
  NSTimer.scheduledTimerWithTimeInterval(delay, false, function () {
    if (controller.notShow && !controller.called) {
      // showHUD("not show")
      return
    }
    if (controller.connection) {
      // 一次只允许一条连接
      // showHUD("on output")
      return
    }
    if (config.apikey === "") {
      showHUD("No apikey!")
      return
    }
    let currentFrame = controller.view.frame
    currentFrame.height = 120
    controller.view.frame = currentFrame
    controller.currentFrame = currentFrame
    controller.beginNotification()
    controller.question = question
    controller.apikey = config.apikey
    // let apikey = "59ee32f24deec485246fd1e8571bf28c.tdoUSxdkl6K321Hm"
    let final_sign = getAuthorization(config.apikey)    
    // showHUD("delay:"+(Date.now()-controller.currentTime))
    const headers = {
      "Content-Type": "application/json",
      Authorization: final_sign
    }
    controller.history.push({role: "user", content: question})
    let body
    if (controller.query) {
      body = {
        prompt: controller.history,
        incremental: false,
        ref:{enable:true,search_query:controller.query}
      }
    }else{
      body = {
        prompt: controller.history,
        incremental: false,
        ref:{enable:false}
      }
    }
    let url = `https://open.bigmodel.cn/api/paas/v3/model-api/chatglm_turbo/sse-invoke`
    const request = controller.initRequest(url, {
        method: "POST",
        headers: headers,
        timeout: 60,
        json: body
      })
    controller.currentTime = Date.now()
    controller.connection = NSURLConnection.connectionWithRequestDelegate(request,controller)
  })
};

/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.continueAsk = function(question,temperature=0.8) {
  // Application.sharedInstance().showHUD(url, this.view.window, 2);
  // this.engineButton.setTitleForState(this.prompts[this.currentPrompt].title, 0);
  // showHUD("delay:"+this.config.delay)
  let config = this.addonController.config
  /**
   * @type {notificationController}
   */
  let controller = this
    if (controller.notShow && !controller.called) {
      // showHUD("not show")
      return
    }
    if (controller.connection) {
      return
    }
    controller.question = question
    controller.apikey = config.apikey
    // let apikey = "59ee32f24deec485246fd1e8571bf28c.tdoUSxdkl6K321Hm"
    let final_sign = getAuthorization(config.apikey)    
    // showHUD("delay:"+(Date.now()-controller.currentTime))
    const headers = {
      "Content-Type": "application/json",
      Authorization: final_sign
    }
    controller.history.push({role: "user", content: question})
    // showHUD("length:"+controller.history.length)
    let body
    body = {
      prompt: controller.history,
      incremental: false,
      ref:{enable:false}
    }
    let url = `https://open.bigmodel.cn/api/paas/v3/model-api/chatglm_turbo/sse-invoke`
    const request = controller.initRequest(url, {
        method: "POST",
        headers: headers,
        timeout: 60,
        json: body
      })
    controller.currentTime = Date.now()
    controller.connection = NSURLConnection.connectionWithRequestDelegate(request,controller)
};
/**
 * @this {notificationController}
 */
notificationController.prototype.finish = function() {
  this.history.push({role:"assistant",content:this[this.targetTextview].text})
  this.query = undefined
  delete this.connection
  this.called = false
  // this.openChatView()
  if (this.onChat || !this.autoHide) {
    return
  }
  this.notifyTimer = NSTimer.scheduledTimerWithTimeInterval(10, false, function () {
    this.hide()
    this.notifyTimer.invalidate()
  })
}

notificationController.prototype.init = function () {
  // /**
  //  * @type {chatglmController}
  //  */
  // let ctr = this
  // showHUD("message")
  this.gobackImage = getImage(this.mainPath + `/goback.png`)
  this.homeImage = getImage(this.mainPath + `/home.png`)
  this.goforwardImage = getImage(this.mainPath + `/goforward.png`)
  this.reloadImage = getImage(this.mainPath + `/reload.png`)
  this.stopImage = getImage(this.mainPath + `/stop.png`)
  this.screenImage = getImage(this.mainPath + `/screen.png`)
  this.bigbangImage = getImage(this.mainPath + `/bigbang.png`)
  this.copyImage = getImage(this.mainPath + `/copy.png`)
  this.titleImage = getImage(this.mainPath + `/title.png`)
  this.tagImage = getImage(this.mainPath + `/tag.png`)
  this.commentImage = getImage(this.mainPath + `/comment.png`)
  this.aiImage = getImage(this.mainPath + `/ai.png`, 3)
  this.aiLinkImage = getImage(this.mainPath + `/aiLink.png`)
  this.chatImage = getImage(this.mainPath + `/chat.png`)
  this.sendImage = getImage(this.mainPath + `/send.png`)
  this.lockImage = getImage(this.mainPath + `/lock.png`)
  this.unlockImage = getImage(this.mainPath + `/unlock.png`)



}
notificationController.prototype.changeButtonOpacity = function(opacity) {
    this.toolbar.layer.opacity = opacity
}
/**
 * @this {notificationController}
 */
notificationController.prototype.setChatLayout = function () {
  try {
    
  let viewFrame = this.chatView.frame
  this.chatToolbar.frame = genFrame(0, viewFrame.height-30, viewFrame.width, viewFrame.height)
  this.userInput.frame = genFrame(0,viewFrame.height-85, viewFrame.width-50, 50)
  this.sendButton.frame = genFrame(viewFrame.width-45,viewFrame.height-85, 45, 50)
  this.scrollView.frame = genFrame(0, 0, viewFrame.width, viewFrame.height-90)
  let size = this.assistant0.sizeThatFits({width:viewFrame.width-10,height:1000})
  this.assistant0.frame = genFrame(5,5, viewFrame.width-10, size.height)
  let initY = size.height+10
  if (this["user"+this.round]) {
    let userSize = this["user"+this.round].sizeThatFits({width:viewFrame.width-10,height:1000})
    let assitSize = this["assistant"+this.round].sizeThatFits({width:viewFrame.width-10,height:1000})
    if (this.preRound == this.round && assitSize.height == this.preHeight) {
      return
    }
    let preFrame = this["assistant"+(this.round-1)].frame
    initY = preFrame.y+preFrame.height+5
    this["user"+this.round].frame = genFrame(5,initY, viewFrame.width-10, userSize.height)
    initY = initY+userSize.height+5
    this["assistant"+this.round].frame = genFrame(5,initY, viewFrame.width-10, assitSize.height)
    initY = initY+assitSize.height+5
    this.preHeight = assitSize.height
  }
  this.preRound = this.round
  this.scrollView.contentSize = {width:400,height:initY+5}
  if (initY > viewFrame.height-95) {
    this.scrollView.setContentOffsetAnimated({x:0,y:initY-viewFrame.height+95},true)
  }
  switch (this.addonController.config.notifyLoc) {
    case 0:
      // showHUD("left")
      this.aiButton.frame = genFrame(-45,0,40,40)
      this.closeChatButton.frame = genFrame(viewFrame.width-30, 0, 30, 30)
      this.chatToken.frame = genFrame(viewFrame.width-135, 0, 100, 30)
      this.chatLocation.frame = genFrame(0,0,55,30)
      break;
    case 1:
      // showHUD("right")
      this.aiButton.frame = genFrame(viewFrame.width+5,0,40,40)
      this.chatLocation.frame = genFrame(viewFrame.width-55,0,55,30)
      this.chatToken.frame = genFrame(35, 0, 100, 30)
      this.closeChatButton.frame = genFrame(0, 0, 30, 30)
      break;
    default:
      break;
  }

  // showHUD(JSON.stringify(this.view.frame))
  } catch (error) {
    showHUD(error)
  }
}

/**
 * @this {notificationController}
 */
notificationController.prototype.setNotiLayout = function () {
  let sizeHeight = this[this.targetTextview].sizeThatFits({width:400,height:1000}).height+5
  if (sizeHeight <= this.preHeight ) {
    return
  }
  this.preHeight = sizeHeight
  let currentFrame = this.view.frame
  let studyHeight = studyController().view.frame.height
  if (sizeHeight+30<120) {
    currentFrame.height = 120
  }else{
    if (sizeHeight+30 > currentFrame.height && sizeHeight-currentFrame.height < 50) {
      currentFrame.height = sizeHeight+30
    }
    if ((currentFrame.y+sizeHeight+30)>studyHeight) {
      currentFrame.height = studyHeight-currentFrame.y
      this.autoHide = false
      this.textviewResponse.frame = genFrame(0, 0, 400, sizeHeight)
      this.notiScroll.contentSize = {width:400,height:sizeHeight}
      this.notiScroll.setContentOffsetAnimated({x:0,y:sizeHeight-this.notiScroll.frame.height},true)
    }
  }
  this.view.frame = currentFrame
  this.currentFrame = currentFrame
}
notificationController.prototype.createButton = function (buttonName,targetAction,superview) {
    this[buttonName] = UIButton.buttonWithType(0);
    this[buttonName].autoresizingMask = (1 << 0 | 1 << 3);
    this[buttonName].setTitleColorForState(UIColor.whiteColor(),0);
    this[buttonName].setTitleColorForState(this.highlightColor, 1);
    this[buttonName].backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this[buttonName].layer.cornerRadius = 8;
    this[buttonName].layer.masksToBounds = true;
    this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);

    if (targetAction) {
      this[buttonName].addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    if (superview) {
      this[superview].addSubview(this[buttonName])
    }else{
      this.view.addSubview(this[buttonName]);
    }
}
/**
 * @this {notificationController}
 */
notificationController.prototype.creatTextView = function (viewName,superview="view",color="#ffffff",alpha=0.8) {
  this[viewName] = UITextView.new()
  // this[viewName] = new UITextView(genFrame(0, 0, 400, 1000))
  this[viewName].font = UIFont.systemFontOfSize(17);
  this[viewName].layer.cornerRadius = 8
  this[viewName].backgroundColor = hexColorAlpha(color,alpha)
  this[viewName].textColor = UIColor.blackColor()
  this[viewName].delegate = this
  this[viewName].editable = true
  this[viewName].scrollEnabled = false
  this[viewName].bounces = false
  this[viewName].layer.borderWidth = 4

  this[superview].addSubview(this[viewName])
  // this[viewName].frame = genFrame(5,5,390,100)
}

notificationController.prototype.hideAllButton = function (frame) {
  this.toolbar.hidden = true
}
notificationController.prototype.showAllButton = function (frame) {
  this.toolbar.hidden = false
}
notificationController.prototype.show = function (notifyLoc) {
try {
  
  let studyFrame = studyController().view.frame
  let height = this.onChat?studyFrame.height-50:120
  this.notifyLoc = notifyLoc
  switch (this.notifyLoc) {
    case 0:
      this.currentFrame.x = 50
      this.view.frame = {x:-300,y:50,width:400,height:height}
      break;
    case 1:
      this.currentFrame.x = studyFrame.width-450
      this.view.frame = {x:studyFrame.width,y:50,width:400,height:height}
      break;
    default:
      break;
  }
  // showHUD(JSON.stringify(this.view.frame))
  let preFrame = this.currentFrame
  preFrame.width = 400
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0.2
  // if (frame) {
  //   this.view.frame = frame
  //   this.currentFrame = frame
  // }
  this.view.hidden = false
    this.setLayout()
  this.hideAllButton()

  UIView.animateWithDurationAnimationsCompletion(0.3,()=>{
    this.view.layer.opacity = preOpacity
    this.view.frame = preFrame
    // this.currentFrame = preFrame
    this.setLayout()
  },
  ()=>{
    this.view.layer.borderWidth = 0
    this.showAllButton()
  })
} catch (error) {
  showHUD(message)
}
}
/**
 * @this {notificationController}
 */
notificationController.prototype.hide = async function () {
  let studyFrame = this.appInstance.studyController(this.view.window).view.bounds
  if (this.connection) {
    this.connection.cancel()
    delete this.connection
  }
  switch (this.notifyLoc) {
    case 0:
      this.currentFrame.x = -this.currentFrame.width
      // this.view.frame = {x:-300,y:10,width:300,height:120}
      break;
    case 1:
      this.currentFrame.x = studyFrame.width
      // this.view.frame = {x:studyFrame.width,y:10,width:300,height:120}
      break;
    default:
      break;
  }
  let preFrame = this.currentFrame
  let preOpacity = this.view.layer.opacity
  let preCustom = this.custom
  // let preFrame = this.view.frame
  this.hideAllButton()
  this.custom = false
  return new Promise((resolve, reject) => {

  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.layer.opacity = 0.2
    this.view.frame = preFrame
    // if (frame) {
    //   this.view.frame = frame
    //   this.currentFrame = frame
    // }
    // this.view.frame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
    // this.currentFrame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
  },
  ()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
    this.view.frame = preFrame
    // this.currentFrame = preFrame
    this.custom = preCustom
    resolve()

    // this.view.frame = preFrame
    // this.currentFrame = preFrame
  })
      
  })
}

/**
 * @this {notificationController}
 */
notificationController.prototype.setLayout = function () {
try {
  

  var viewFrame = this.toolbar.bounds;
  var width    = viewFrame.width
  var height   = viewFrame.height
  viewFrame.height = viewFrame.height-30
  switch (this.notifyLoc) {
    case 0:
      this.aiButton.frame = genFrame(-45,0,40,40)
      this.screenButton.frame = genFrame(width-30,0,30,30)
      this.bigbangButton.frame = genFrame(width-65,0,30,30)
      this.commentButton.frame = genFrame(width-100,0,30,30)
      this.titleButton.frame = genFrame(width-135,0,30,30)
      this.copyButton.frame = genFrame(width-170,0,30,30)
      this.aiLinkButton.frame = genFrame(width-205,0,30,30)
      this.reloadButton.frame = genFrame(width-240,0,30,30)
      this.chatButton.frame = genFrame(width-275,0,30,30)
      this.locationButton.frame = genFrame(90,0,30,30)
      this.promptButton.frame = genFrame(0,0,85,30)

      break;
    case 1:
      this.aiButton.frame = genFrame(width+5,0,40,40)
      this.screenButton.frame = genFrame(0,0,30,30)
      this.bigbangButton.frame = genFrame(35,0,30,30)
      this.commentButton.frame = genFrame(70,0,30,30)
      this.titleButton.frame = genFrame(105,0,30,30)
      this.copyButton.frame = genFrame(140,0,30,30)
      this.aiLinkButton.frame = genFrame(175,0,30,30)
      this.reloadButton.frame = genFrame(210,0,30,30)
      this.chatButton.frame = genFrame(245,0,30,30)
      this.locationButton.frame = genFrame(viewFrame.width-120,0,30,30)
      this.promptButton.frame = genFrame(viewFrame.width-85,0,90,30)
      break;
    default:
      break;
  }
} catch (error) {
  showHUD(error)
}
}

notificationController.prototype.beginNotification = function () {
    this.textviewResponse.text = "I'm thinking..."
    this.locationButton.setTitleForState(this.addonController.config.notifyLoc?' R ':' L ',0)
    try {
    this.promptButton.setTitleForState(this.addonController.prompts[this.currentPrompt].title ,0)
    } catch (error) {
      showHUD(error)
    }
    if (this.view.hidden || this.notifyLoc !== this.config.notifyLoc) {
      this.show(this.config.notifyLoc)
    }

    this.appInstance.studyController(this.view.window).view.bringSubviewToFront(this.view)
    if (this.notifyTimer) {
      this.notifyTimer.invalidate()
    }
  }

notificationController.prototype.getTextForAction = function (params) {
  let selectedRange = this.textviewResponse.selectedRange
  let text = this.textviewResponse.text
  if (selectedRange.length) {
    let selectedText = text.slice(selectedRange.location,selectedRange.location+selectedRange.length)
    return selectedText
  }else{
    return text
  }
}


notificationController.prototype.initRequest = function (url,options) {
  const request = NSMutableURLRequest.requestWithURL(genNSURL(url))
  request.setHTTPMethod(options.method ?? "GET")
  request.setTimeoutInterval(options.timeout ?? 10)
  const headers = {
    "User-Agent":
      "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15",
    "Content-Type": "application/json",
    Accept: "text/event-stream"
  }
  request.setAllHTTPHeaderFields({
    ...headers,
    ...(options.headers ?? {})
  })
  if (options.search) {
    request.setURL(
      genNSURL(
        `${url.trim()}?${Object.entries(options.search).reduce((acc, cur) => {
          const [key, value] = cur
          return `${acc ? acc + "&" : ""}${key}=${encodeURIComponent(value)}`
        }, "")}`
      )
    )
  } else if (options.body) {
    request.setHTTPBody(NSData.dataWithStringEncoding(options.body, 4))
  } else if (options.form) {
    request.setHTTPBody(
      NSData.dataWithStringEncoding(
        Object.entries(options.form).reduce((acc, cur) => {
          const [key, value] = cur
          return `${acc ? acc + "&" : ""}${key}=${encodeURIComponent(value)}`
        }, ""),
        4
      )
    )
  } else if (options.json) {
    request.setHTTPBody(
      NSJSONSerialization.dataWithJSONObjectOptions(
        options.json,
        1
      )
    )
  }
  return request
}
notificationController.prototype.openChatView = function (params) {
    // if (this.connection) {
    //   showHUD("Wait...")
    //   return
    // }
    // this.round = 0
    // if (this.notifyTimer) {
    //   this.notifyTimer.invalidate()
    // }
    // this.notificationView.hidden = true
    // this.onChat = true
    this.chatView = new UIView(this.view.bounds)
    this.chatView.layer.cornerRadius = 8
    this.chatView.backgroundColor = hexColorAlpha("#ffffff",0.0)
    this.view.addSubview(this.chatView)
}
/**
 * @type {UIView}
 */
notificationController.prototype.view