JSB.require('utils');
JSB.require('CryptoJS')
JSB.require('network')
// JSB.require('base64')
var chatglmController = JSB.defineClass('chatglmController : UIViewController <UIWebViewDelegate>', {
  viewDidLoad: function() {
    self.init()
    self.appInstance = Application.sharedInstance();
    self.custom = false;
    self.customMode = "None"
    // Application.sharedInstance().showHUD("process:0",Application.sharedInstance().focusWindow,5)
    self.dynamic = true;
    self.miniMode = false;
    self.shouldCopy = false
    self.shouldComment = false
    self.selectedText = '';
    self.searchedText = '';
    self.engine = 'Bing'
    self.isLoading = false;
    self.toolbarOn = true;
    self.view.frame = {x:50,y:50,width:(self.appInstance.osType !== 1) ? 419 : 365,height:450}
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.isMainWindow = true
    self.title = "main"
    self.test = [0]
    self.moveDate = Date.now()
    self.color = [true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true]
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.cornerRadius = 11
    self.view.layer.opacity = 1.0
    self.view.layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
    self.view.layer.borderWidth = 0
    self.searchOrder = self.config.searchOrder
    self.autoAction = self.config.autoAction
    self.onSelection = self.config.onSelection
    self.onNote = self.config.onNote
    self.onNewExcerpt = self.config.onNewExcerpt
    self.notifyLoc = self.config.notifyLoc
    if (!self.config.delay) {
      self.config.delay = 0
    }
    if (!self.config.colorConfig) {
      self.config.colorConfig = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]
    }
    if (self.config.ignoreShortText == undefined) {
      self.config.ignoreShortText = false
    }
    // >>> DeepL view >>>
    self.webview = new UIWebView(self.view.bounds);
    // NSUserDefaults.standardUserDefaults().setObjectForKey('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"UserAgent")

    //  Application.sharedInstance().showHUD("error", self.view.window, 2);
    self.webview.url = self.homePageURL;
    self.webview.backgroundColor = UIColor.whiteColor();
    self.webview.scalesPageToFit = true;
    self.webview.autoresizingMask = (1 << 1 | 1 << 4);
    self.webview.delegate = self;
    // self.webview.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
    self.webview.scrollView.delegate = self;
    self.webview.layer.cornerRadius = 15;
    self.webview.layer.masksToBounds = true;
    self.webview.layer.borderColor = hexColorAlpha("#9bb2d6",0.8);
    self.webview.layer.borderWidth = 0
    self.highlightColor = UIColor.blendedColor( hexColorAlpha("#2c4d81",0.8),
      self.appInstance.defaultTextColor,
      0.8
    );

    self.webview.hidden = true;
    self.webview.lastOffset = 0;
    self.view.addSubview(self.webview);

    self.responseView = UIView.new()
    self.responseView.backgroundColor = hexColorAlpha("#f3f3f3")
    self.responseView.layer.cornerRadius = 13
    self.responseView.hidden = true
    self.view.addSubview(self.responseView)

    self.textviewResponse = UITextView.new()
    self.textviewResponse.font = UIFont.systemFontOfSize(16);
    self.textviewResponse.layer.cornerRadius = 8
    self.textviewResponse.backgroundColor = hexColorAlpha("#ffffff",0.8)
    self.textviewResponse.textColor = UIColor.blackColor()
    self.responseView.addSubview(self.textviewResponse)
    self.textviewResponse.text = `Loading...`
    self.textviewResponse.bounces = true

    self.textviewAsk = UITextView.new()
    self.textviewAsk.font = UIFont.systemFontOfSize(16);
    self.textviewAsk.layer.cornerRadius = 8
    self.textviewAsk.backgroundColor = hexColorAlpha("#a9ea7a",0.8)
    self.textviewAsk.textColor = UIColor.blackColor()
    self.responseView.addSubview(self.textviewAsk)
    self.textviewAsk.text = `Input here`
    self.textviewAsk.bounces = true

    self.createButton("toolbar")
    self.toolbar.backgroundColor = hexColorAlpha("#727f94",0.)

    self.createButton("closeButton","closeButtonTapped:")
    self.closeButton.setTitleForState('✖️', 0);
    self.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);

    self.createButton("maxButton","maxButtonTapped:")
    self.maxButton.setTitleForState('➕', 0);
    self.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);

    self.createButton("minButton","minButtonTapped:")
    self.minButton.setTitleForState('➖', 0);
    self.minButton.titleLabel.font = UIFont.systemFontOfSize(10);

    // self.createButton("screenButton","changeScreen:","toolbar")
    self.createButton("screenButton","changeScreen:","toolbar")

    self.screenButton.setImageForState(self.screenImage,0)

    self.createButton("engineButton","changePrompts:","toolbar")
    self.engineButton.setTitleForState(self.prompts[self.config.currentPrompt].title, 0);
    self.engineButton.titleLabel.font = UIFont.boldSystemFontOfSize(16);

    self.createButton("homeButton","homeButtonTapped:","toolbar")
    self.homeButton.setImageForState(self.homeImage,0)

    self.createButton("settingButton","openSettingView:","toolbar")
    self.settingButton.setImageForState(self.settingImage,0)

    self.createButton("searchButton","searchButtonTapped:","toolbar")
    self.searchButton.setTitleForState("🤖",0)
    // self.searchButton.setImageForState(self.aiImage,0)

    self.createButton("moveButton")


    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
  },
  viewWillAppear: function(animated) {
    self.webview.delegate = self;
  },
  viewWillDisappear: function(animated) {
    self.webview.stopLoading();
    self.webview.delegate = null;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },
viewWillLayoutSubviews: function() {
    // Application.sharedInstance().showHUD("test", self.view.window, 2);
    // Application.sharedInstance().showHUD("process:5",Application.sharedInstance().focusWindow,5)

    if (self.miniMode) {
      // self.webview.hidden = true
      return
    }
    let buttonHeight = 25
    // self.view.frame = self.currentFrame
    var viewFrame = self.view.bounds;
    var width    = viewFrame.width
    var height   = viewFrame.height
    self.closeButton.frame = genFrame(width-18,0,18,18)
    self.maxButton.frame = genFrame(width-43,0,18,18)
    self.minButton.frame = genFrame(width-68,0,18,18)

    if (self.toolbarOn) {
      self.toolbar.frame = genFrame(1, height-25, width-2,buttonHeight)
      self.screenButton.frame = genFrame(width-42,0,40,buttonHeight)
      self.searchButton.frame = {  x: width - 192,  y: 0,  width: 47,  height: buttonHeight};
      self.webview.frame = {x:1,y:6,width:width-2,height:height-36}
      self.settingButton.hidden = false

    }else{
      self.toolbar.frame = genFrame(1,height-30,width-2,buttonHeight)
      self.screenButton.frame = genFrame(width-40,0,33,buttonHeight)
      self.searchButton.frame = {  x: width - 75,  y: 0,  width: 30,  height: buttonHeight};
      self.webview.frame = {x:1,y:6,width:width-2,height:height-6}
      self.settingButton.hidden = true

    }
    self.settingButton.frame = genFrame(0,0,40,buttonHeight)
    self.homeButton.frame = genFrame(45,0,45,buttonHeight)    
    self.engineButton.frame = {x: width - 140,y: 0,width: 93,height: buttonHeight};
    self.moveButton.frame = {  x: width*0.5-75,  y: 0,  width: 150,  height: 12,};
    self.engineButton.hidden = !self.toolbarOn
    self.screenButton.hidden = false
    self.responseView.frame = {x:1,y:6,width:width-2,height:height-36}
    height = height-36
    self.textviewAsk.frame = {x:100,y:10,width:width-110,height:height*0.5-20}
    self.textviewResponse.frame = {x:10,y:height*0.5,width:width-110,height:height*0.5-10}

    self.settingViewLayout()
    self.refreshLayout()

  },

  webViewDidStartLoad: function(webView) {

    // let requestFromHomepage = self.webview.url === "https://m.inftab.com/"
    let currentURL = webView.request.URL().absoluteString();
    if (!currentURL) {return}
    self.refreshButton.setImageForState(self.stopImage,0)
    self.changeButtonOpacity(0.5)
    UIApplication.sharedApplication().networkActivityIndicatorVisible = true;
  },
  webViewDidFinishLoad: function(webView) {
    self.refreshButton.setImageForState(self.reloadImage,0)
    self.changeButtonOpacity(1.0)
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },
  webViewDidFailLoadWithError: function(webView, error) {
    self.refreshButton.setImageForState(self.reloadImage,0)
    self.changeButtonOpacity(1.0)
  },
  webViewShouldStartLoadWithRequestNavigationType: function(webView,request,type){
    return true;
  },
  changeScreen: function(sender) {
    var commandTable = [
      {title:'🌗 Left',object:self,selector:'splitScreen:',param:'left',checked:self.customMode==="left"},
      {title:'🌘 Left 1/3',object:self,selector:'splitScreen:',param:'left13',checked:self.customMode==="left13"},
      {title:'🌓 Right',object:self,selector:'splitScreen:',param:'right',checked:self.customMode==="right"},
      {title:'🌒 Right 1/3',object:self,selector:'splitScreen:',param:'right13',checked:self.customMode==="right13"},
      {title:'🌟 Toolbar',object:self,selector:'toggleToolbar:',param:'right',checked:self.toolbarOn},
      {title:'🫧 Opacity',object:self,selector:'changeOpacity:',param:sender},
      {title:'🎬 Screenshot',object:self,selector:'screenshot:',param:self.view.frame.width>1000?self.view.frame.width:1000},
    ];
    self.view.popoverController = getPopoverAndPresent(sender,commandTable,200)
  },
  changePrompts: function(sender) {
    var commandTable = self.config.promptNames.map(promptName => {
      return {title:self.prompts[promptName].title,object:self,selector:'askWithPrompt:',param:promptName,checked:self.config.currentPrompt===promptName}
    })
    self.view.popoverController = getPopoverAndPresent(sender,commandTable,200)
  },

  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    self.view.popoverController = getPopoverAndPresent(sender,commandTable,100)
  },
  changeSearchOrder: function(sender) {
    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'Title → Excerpt → Comment',object:self,selector:'setSearchOrder:',param:[1,2,3],checked:self.searchOrder ==[1,2,3]},
      {title:'Title → Comment → Excerpt',object:self,selector:'setSearchOrder:',param:[1,3,2],checked:self.searchOrder==[1,3,2]},
      {title:'Excerpt → Title → Comment',object:self,selector:'setSearchOrder:',param:[2,1,3],checked:self.searchOrder==[2,1,3]},
      {title:'Excerpt → Comment → Title',object:self,selector:'setSearchOrder:',param:[2,3,1],checked:self.searchOrder==[2,3,1]},
      {title:'Comment → Title → Excerpt',object:self,selector:'setSearchOrder:',param:[3,1,2],checked:self.searchOrder==[3,1,2]},
      {title:'Comment → Excerpt → Title',object:self,selector:'setSearchOrder:',param:[3,2,1],checked:self.searchOrder==[3,2,1]},
    ];
    self.view.popoverController = getPopoverAndPresent(sender,commandTable,250)
  },
  setSearchOrder:function (order) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.searchOrder = order
    // self.appInstance.showHUD("Order: "+getOrderText(self.searchOrder),self.view.window,2)
    self.orderButton.setTitleForState(getOrderText(self.searchOrder),0)
    self.config.searchOrder = self.searchOrder
    setLocalDataByKey(self.config,"MNChatglm_config")
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
  },
  openSettingView:function () {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    // self.settingController.view.hidden = false
    if (!self.settingView) {
      self.createSettingView()
    }else{
    }
    self.settingViewLayout()
    
    try {
      self.setButtonText(self.config.promptNames,self.config.currentPrompt)
      self.setTextview(self.config.currentPrompt)
      self.settingView.hidden = false
    } catch (error) {
    self.appInstance.showHUD(error,self.view.window,2)
      
    }

    // self.view.addSubview(self.tabView)
  },
  toggleToolbar:function (opacity) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    // Application.sharedInstance().showHUD(self.toolbarOn,self.view.window,2)
    self.toolbarOn = !self.toolbarOn
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.toolbarOn, 'MNBrowser_toolbar');
    // self.searchButton.hidden = !self.toolbarOn
    self.homeButton.hidden = !self.toolbarOn

    // self.screenButton.hidden = !self.toolbarOn
    self.engineButton.hidden = !self.toolbarOn
    var viewFrame = self.view.bounds;
    UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
      if (self.toolbarOn) {
        self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height-40}
      }else{
        self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height}
      }
    })
  },
  askWithPrompt: function (prompt) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.config.currentPrompt = prompt
    self.engineButton.setTitleForState(self.prompts[self.config.currentPrompt].title,0)
    setLocalDataByKey(self.config,"MNChatglm_config")
    if (self.selectedText.length) {
      self.ask(self.selectedText) 
    }else{
      self.ask(self.searchedText)//用户可能只是想换个搜索引擎再次搜索
    }
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
  },
  bigbang: async function(){
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let url = await self.getCurrentURL()
    // let text = await self.getSelectedTextInWebview()
    let text = await self.getTextInWebview()
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('bigbangText', self.view.window, {text:text,url:url})

    // UIPasteboard.generalPasteboard().string = `[${text}](${url})`
    // Application.sharedInstance().showHUD("链接已复制",self.view.window,2)
    // Application.sharedInstance().showHUD(ret,self.view.window,2)
  
  },
  resetConfig: function (engine) {

    let defaultPrompts = {
        Translate:                      {title: "翻译",context:"请翻译下面这段话：{{context}}"},
        Keyword:                        {title: "关键词",context:"请为下面这段话提取关键词：{{context}}"},
        Title:                          {title: "标题",context:"请为下面这段话生成标题：{{context}}"}
    }
    // self.toolbarOn = true
    self.prompts = defaultPrompts
    self.config.promptNames = Object.keys(self.prompts)
    self.config.currentPrompt = self.config.promptNames[0]
    self.engineButton.setTitleForState(self.prompts[self.config.currentPrompt].title, 0);
    self.setButtonText(self.config.promptNames,self.config.currentPrompt)
    self.setTextview(self.config.currentPrompt)
    setLocalDataByKey(self.config,'MNChatglm_config')
    setLocalDataByKey(self.prompts,"MNChatglm_prompts")
  },
  screenshot: function (width) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.webview.takeSnapshotWithWidth(width,(snapshot)=>{
      UIPasteboard.generalPasteboard().setDataForPasteboardType(snapshot.pngData(),"public.png")
      
      self.appInstance.showHUD('截图已复制到剪贴板',self.view.window,2)
    })
  },
  toggleWindowLocation: function () {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    switch (self.config.notifyLoc) {
      case 1:
        self.config.notifyLoc = 0
        self.windowLocationButton.setTitleForState("Notification: Left",0)
        self.notifyController.locationButton.setTitleForState("Left",0)
        break;
      case 0:
        self.config.notifyLoc = 1
        self.windowLocationButton.setTitleForState("Notification: Right",0)
        self.notifyController.locationButton.setTitleForState("Right",0)
        break;
      default:
        break;
    }
    // self.notifyController.config = self.config
    setLocalDataByKey(self.config,'MNChatglm_config')
  },
  homeButtonTapped: function() {
    self.homePage()
  },
  searchButtonTapped: async function() {
  self.ask(self.selectedText)
  },
  closeButtonTapped: function() {
    // self.view.hidden = true;
    // self.custom = false;
    // self.dynamic = true;
    if (self.addonBar) {
      self.hide(self.addonBar.frame)
    }else{
      self.hide()
    }
    self.searchedText = ""
  },
 closeConfigTapped: function () {
  let preOpacity = self.settingView.layer.opacity
  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    self.settingView.layer.opacity = 0
  },()=>{
    self.settingView.layer.opacity = preOpacity
    self.settingView.hidden = true
  })
 },
 splitScreen: function (mode) {
  if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
  self.lastFrame = self.view.frame
  // let studyFrame = self.appInstance.studyController(self.view.window).view.bounds
  // let height = studyFrame.height;
  // let width = studyFrame.width;
  // let splitLine = getSplitLine()
  // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
  // self.view.frame = {x:40,y:50,width:splitLine-40,height:height-50}
  self.custom = true;
  self.customMode = mode
  self.dynamic = false;
  self.webview.hidden = false
  self.hideAllButton()
  UIView.animateWithDurationAnimationsCompletion(0.3,()=>{
    self.setSplitScreenFrame(mode)
  },
  ()=>{
    self.showAllButton()
  })
 },
  maxButtonTapped: function() {
    if (self.customMode === "full") {
      self.customMode = "none"
      self.custom = false;
      // self.screenButton.hidden = false
      self.hideAllButton()
      UIView.animateWithDurationAnimationsCompletion(0.3,()=>{
        self.view.frame = self.lastFrame
        self.currentFrame = self.lastFrame
      },
      ()=>{
        self.showAllButton()
      
      })
      return
    }
    const frame = Application.sharedInstance().studyController(self.view.window).view.bounds
    self.lastFrame = self.view.frame
    self.customMode = "full"
    self.custom = true;
    self.dynamic = false;
    self.webview.hidden = false
    self.hideAllButton()


    UIView.animateWithDurationAnimationsCompletion(0.3,()=>{
      self.view.frame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
      self.currentFrame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
    },
    ()=>{
      self.showAllButton()
    })
  },
  minButtonTapped: function() {
    self.dynamic = false;
    self.miniMode = true
    let studyFrame = self.appInstance.studyController(self.view.window).view.bounds
    let studyCenter = self.appInstance.studyController(self.view.window).view.center.x

    let viewCenter = self.view.center.x
    if (viewCenter>studyCenter) {
      self.toMinimode(genFrame(studyFrame.width-40,self.view.frame.y,40,40))
    }else{
      self.toMinimode(genFrame(0,self.view.frame.y,40,40))
    }
  },
  onMoveGesture:function (gesture) {
    self.dynamic = false;
    let locationToMN = gesture.locationInView(self.appInstance.studyController(self.view.window).view)
    if (!self.locationToButton || !self.miniMode && (Date.now() - self.moveDate) > 100) {
      // self.appInstance.showHUD("state:"+gesture.state, self.view.window, 2);
      let translation = gesture.translationInView(self.appInstance.studyController(self.view.window).view)
      let locationToBrowser = gesture.locationInView(self.view)
      let locationToButton = gesture.locationInView(gesture.view)
      let buttonFrame = self.moveButton.frame
      let newY = locationToButton.y-translation.y 
      let newX = locationToButton.x-translation.x
      if (gesture.state !== 3 && (newY<buttonFrame.height+5 && newY>-5 && newX<buttonFrame.width+5 && newX>-5 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20)) {
        self.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
        self.locationToButton = {x:newX,y:newY}
      }
      // if ((newY<buttonFrame.height && newY>0 && newX<buttonFrame.width && newX>0 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20) || !self.locationToBrowser) {

      // }
    }
    self.moveDate = Date.now()
    // let location = {x:locationToMN.x - self.locationToBrowser.x,y:locationToMN.y -self.locationToBrowser.y}
    let location = {x:locationToMN.x - self.locationToButton.x-gesture.view.frame.x,y:locationToMN.y -self.locationToButton.y-gesture.view.frame.y}

    // showHUD("test")
    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = self.appInstance.studyController(self.view.window).view.bounds
    let y = location.y
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = location.x
    if (!self.miniMode) {
      if (locationToMN.x<40) {
        self.toMinimode(genFrame(0,locationToMN.y,40,40))
        return
      }
      if (locationToMN.x>studyFrame.width-40) {
        self.toMinimode(genFrame(studyFrame.width-40,locationToMN.y,40,40))
        return
      }
    }else{
      if (locationToMN.x<50) {
        self.view.frame = genFrame(0,locationToMN.y-20,40,40)
        return
      }else if (locationToMN.x>studyFrame.width-50) {
        self.view.frame = genFrame(studyFrame.width-40,locationToMN.y-20,40,40)
        return
      }else if (locationToMN.x>50) {
        let preOpacity = self.view.layer.opacity
        self.view.layer.opacity = 0
        self.hideAllButton()
        UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
          self.view.frame = genFrame(x,y,self.lastFrame.width,self.lastFrame.height)
          self.view.layer.opacity = preOpacity
          self.currentFrame = self.view.frame
        },
        ()=>{
          self.moveButton.frame = genFrame(viewFrame.x + viewFrame.width*0.5-75,viewFrame.y+5,150,10)
          self.view.layer.borderWidth = 0
          // self.view.layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
          self.view.hidden = false
          self.webview.hidden = false
          self.showAllButton()
          self.toolbar.hidden = false
          if (self.toolbarOn) {
            self.homeButton.hidden = false
            self.engineButton.hidden = false
          }
        })
        self.miniMode = false
        return
      }
    }
    
    if (self.custom) {
      // Application.sharedInstance().showHUD(self.custom, self.view.window, 2);
      self.customMode = "None"
      UIView.animateWithDurationAnimations(0.2,()=>{
        self.view.frame = genFrame(x,y,self.lastFrame.width,self.lastFrame.height)
        self.currentFrame  = self.view.frame
      })
    }else{
      self.view.frame = genFrame(x,y,frame.width,frame.height)
      self.currentFrame  = self.view.frame
    }
    self.custom = false;
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    self.customMode = "none"
    let baseframe = gesture.view.frame
    let locationToBrowser = gesture.locationInView(self.view)
    let frame = self.view.frame
    let width = locationToBrowser.x+baseframe.width*0.5
    let height = locationToBrowser.y+baseframe.height*0.5
    if (width <= 375) {
      width = 375
    }
    if (height <= 500) {
      height = 500
    }
    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
    self.currentFrame  = self.view.frame
  },
  knowledgeButtonTapped: function (params) {
    self.configView.hidden = true
    self.donationView.hidden = true
    self.advanceView.hidden = true
    self.autoActionView.hidden = true
    self.knowledgeView.hidden = false
    self.configButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.advancedButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.donationButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.knowledgeButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    self.actionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)


  },
  actionButtonTapped: function (params) {
    self.configView.hidden = true
    self.donationView.hidden = true
    self.advanceView.hidden = true
    self.autoActionView.hidden = false
    self.knowledgeView.hidden = true
    self.configButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.advancedButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.donationButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.knowledgeButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.actionButton.backgroundColor = hexColorAlpha("#457bd3",0.8)


  },
  advancedButtonTapped: function (params) {
    self.configView.hidden = true
    self.donationView.hidden = true
    self.advanceView.hidden = false
    self.knowledgeView.hidden = true
    self.autoActionView.hidden = true

    self.configButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.advancedButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    self.donationButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.knowledgeButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.actionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)

  },
  donationButtonTapped: function (params) {
    self.configView.hidden = true
    self.advanceView.hidden = true
    self.donationView.hidden = false
    self.knowledgeView.hidden = true
    self.autoActionView.hidden = true

    self.donationButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    self.configButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.advancedButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.actionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.knowledgeButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
  },
  configButtonTapped: function (params) {
    self.configView.hidden = false
    self.advanceView.hidden = true
    self.knowledgeView.hidden = true
    self.autoActionView.hidden = true
    self.donationView.hidden = true
    self.configButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    self.advancedButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.donationButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.actionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.knowledgeButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)

  },
  configSaveTapped: function (params) {
    try {
      let config = {title:self.titleInput.text,context:self.contextInput.text}
      self.prompts[self.config.currentPrompt] = config
      self.setButtonText(self.config.promptNames,self.config.currentPrompt)
      self.engineButton.setTitleForState(config.title,0)
      setLocalDataByKey(self.prompts,"MNChatglm_prompts")
      showHUD("Save prompt: "+self.prompts[self.config.currentPrompt].title)
    } catch (error) {
      self.appInstance.showHUD(error, self.view.window, 2);
    }
    // self.appInstance.studyController(self.view.window).focusNoteInMindMapById("FA871E6D-A175-4D1E-8568-63510CA82E42")
  },
  saveKnowledgeButtonTapped: function (params) {
    try {
      self.knowledge = self.knowledgeInput.text
      setLocalDataByKey(self.knowledge,"MNChatglm_knowledge")
      showHUD("Save knowledge")
    } catch (error) {
      self.appInstance.showHUD(error, self.view.window, 2);
    }
    // self.appInstance.studyController(self.view.window).focusNoteInMindMapById("FA871E6D-A175-4D1E-8568-63510CA82E42")
  },
  configAddTapped: function (params) {
    self.titleInput.text = "New prompt"
    self.contextInput.text = "input your prompt"
    let i = 0
    while (self.prompts["customEngine"+i]) {
      i = i+1
    }
    let prompts = self.prompts
    let config = {title:self.titleInput.text,context:self.contextInput.text}
    prompts["customEngine"+i] = config
    self.prompts = prompts
    self.config.promptNames = self.config.promptNames.concat(("customEngine"+i))
    self.setButtonText(self.config.promptNames,"customEngine"+i)
    self.config.currentPrompt = "customEngine"+i
    self.engineButton.setTitleForState("New prompt",0)
    self.refreshLayout()
    setLocalDataByKey(self.config,'MNChatglm_config')
    setLocalDataByKey(self.prompts,"MNChatglm_prompts")
  },
  configDeleteTapped: function (params) {
    // try {
      

    delete self.prompts[self.config.currentPrompt]
    self.config.promptNames = self.config.promptNames.filter(item=>item !== self.config.currentPrompt)
    self.config.currentPrompt = self.config.promptNames[0]
    // self.searchButton.setTitleForState(self.prompts[self.config.currentPrompt].symbol, 0);
    self.engineButton.setTitleForState(self.prompts[self.config.currentPrompt].title, 0);
    self.setButtonText(self.config.promptNames,self.config.currentPrompt)
    self.refreshLayout()
    //     } catch (error) {
    //   showHUD(error)
    // }
    setLocalDataByKey(self.config,"MNChatglm_config")
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.prompts,"MNChatglm_prompts")

    // try {
    // let config = JSON.parse(self.contextInput.text)
    // if (self.configMode === 0) {
    //   self.entries[self.configEngine] = config
    // }else{
    // }
    // } catch (error) {
    // self.appInstance.showHUD(error, self.view.window, 2);
    // }
    // self.appInstance.studyController(self.view.window).focusNoteInMindMapById("FA871E6D-A175-4D1E-8568-63510CA82E42")
  },
  pasteApiKey:function (params) {
    let apikey = UIPasteboard.generalPasteboard().string
    self.apiKeyInput.text = apikey
    self.config.apikey = apikey
    setLocalDataByKey(self.config,'MNChatglm_config')
  },
  toggleSelected:function (sender) {
    sender.isSelected = !sender.isSelected
    // self.appInstance.showHUD(text,self.view.window,2)
    let title = sender.id
    self.config.currentPrompt = title
    self.engineButton.setTitleForState(self.prompts[title].title,0)
    // showHUD(self.words)
    self.words.forEach((entryName,index)=>{
      if (entryName !== title) {
        self["nameButton"+index].isSelected = false
        self["nameButton"+index].backgroundColor = hexColorAlpha("#9bb2d6",0.8);
      }
    })
    if (sender.isSelected) {
      self.setTextview(title)
    // showHUD("to dark:"+title)

      sender.backgroundColor = hexColorAlpha("#457bd3",0.8)
    }else{
    // showHUD("to light:"+title)

      sender.backgroundColor = hexColorAlpha("#9bb2d6",0.8);
    }
    setLocalDataByKey(self.config,'MNChatglm_config')
  },
  toggleAutoAction:function () {
    self.config.autoAction = !self.config.autoAction
    setLocalDataByKey(self.config,'MNChatglm_config')
    if (self.config.autoAction) {
      self.autoActionButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
      self.autoActionButton.setTitleForState("Auto Action: ✅")

    }else{
      self.autoActionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
      self.autoActionButton.setTitleForState("Auto Action: ❌")
    }
    self.onSelectionButton.hidden = !self.config.autoAction
    self.onNewExcerptButton.hidden = !self.config.autoAction
    self.onWebModeButton.hidden = !self.config.autoAction
    self.onNoteButton.hidden = !self.config.autoAction
    self.ignoreButton.hidden = !self.config.autoAction

    for (let index = 0; index < 32; index++) {
      self["ColorButton"+index].hidden = !self.config.autoAction
    }
    self.appInstance.studyController(self.view.window).refreshAddonCommands();
  },
  toggleOnSelection:function () {
    self.config.onSelection = !self.config.onSelection
    setLocalDataByKey(self.config,'MNChatglm_config')
    if (self.config.onSelection) {
      self.onSelectionButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
      self.onSelectionButton.setTitleForState("On Selection: ✅")
    }else{
      self.onSelectionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
      self.onSelectionButton.setTitleForState("On Selection: ❌")
    }
  },
  toggleOnNote:function () {
    self.config.onNote = !self.config.onNote
    setLocalDataByKey(self.config,'MNChatglm_config')

    if (self.config.onNote) {
      self.onNoteButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
      self.onNoteButton.setTitleForState("On Note: ✅")
    }else{
      self.onNoteButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
      self.onNoteButton.setTitleForState("On Note: ❌")
    }
  },
  toggleOnNewExcerpt:function () {
    self.config.onNewExcerpt = !self.config.onNewExcerpt
    setLocalDataByKey(self.config,'MNChatglm_config')
    if (self.config.onNewExcerpt) {
      self.onNewExcerptButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
      self.onNewExcerptButton.setTitleForState("On New Excerpt: ✅")
    }else{
      self.onNewExcerptButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
      self.onNewExcerptButton.setTitleForState("On New Excerpt: ❌")
    }
  },
  toggleOnWebMode:function () {
    self.config.onWebMode = !self.config.onWebMode
    setLocalDataByKey(self.config,'MNChatglm_config')
    if (self.config.onWebMode) {
      self.onWebModeButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
      self.onWebModeButton.setTitleForState("On New Excerpt: ✅")
    }else{
      self.onWebModeButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
      self.onWebModeButton.setTitleForState("On New Excerpt: ❌")
    }
  },
  openDev:function () {
    self.settingView.hidden = true
    self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString("https://open.bigmodel.cn/overview")));
  },
  changeDelay: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'2.0s',object:self,selector:'changeDelayTo:',param:2.0},
      {title:'1.5s',object:self,selector:'changeDelayTo:',param:1.5},
      {title:'1.0s',object:self,selector:'changeDelayTo:',param:1.0},
      {title:'0.5s',object:self,selector:'changeDelayTo:',param:0.5}
    ];
    self.view.popoverController = getPopoverAndPresent(sender,commandTable,100)
  },
  changeDelayTo: function(delay) {
    self.config.delay = delay
    self.delayButton.setTitleForState("Delay: "+delay+"s")
    setLocalDataByKey(self.config,'MNChatglm_config')
    showHUD("Set delay to "+delay+"s")
  },
  toggleColorConfig: function (button) {
    if (self.config.colorConfig[button.index]) {
      self.config.colorConfig[button.index] = 0
      button.setTitleForState("✖️",0)
    }else{
      self.config.colorConfig[button.index] = 1
      button.setTitleForState("✓",0)
    }
    setLocalDataByKey(self.config,'MNChatglm_config')
    // showHUD("colorIndex:"+button.index)
  },
  toggleIgnoreShortText:function (button) {
    self.config.ignoreShortText = !self.config.ignoreShortText
    button.setTitleForState("Ignore short text: "+(self.config.ignoreShortText?"✅":"🚫"))
    if (self.config.ignoreShortText) {
      self.ignoreButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    }else{
      self.ignoreButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    }
    setLocalDataByKey(self.config,'MNChatglm_config')
  },
});
chatglmController.prototype.init = function () {
  // /**
  //  * @type {chatglmController}
  //  */
  // let ctr = this
  this.homePageURL = 'https://chatglm.cn/detail'
  this.homeImage = getImage(this.mainPath + `/home.png`)
  this.gobackImage = getImage(this.mainPath + `/goback.png`)
  this.goforwardImage = getImage(this.mainPath + `/goforward.png`)
  this.reloadImage = getImage(this.mainPath + `/reload.png`)
  this.stopImage = getImage(this.mainPath + `/stop.png`)
  this.screenImage = getImage(this.mainPath + `/screen.png`)
  this.QRCodeImage = getImage(this.mainPath + `/QRCode.png`)
  this.settingImage = getImage(this.mainPath + `/setting.png`)

}
chatglmController.prototype.homePage = function() {

  this.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
  this.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(this.homePageURL)));
  this.webview.hidden = false
  this.searchedText = "";
  // this.mdxDictView.hidden = false
  // var url = `${this.webview.url}#en/${this.webview.lanCode}/${encodeURIComponent(text.replaceAll('/', '\\/'))}`;
};

chatglmController.prototype.ask = async function(text) {
  var question = this.getQuestion(text).replaceAll("\n","\\n")
  this.runJavaScript(`if (typeof(t) !== "undefined") {
      t.value='${question}';
      t.dispatchEvent(evt)
    }else{
      let t = document.getElementsByTagName('textarea')[0];
      let evt = document.createEvent('HTMLEvents');
      evt.initEvent('input', true, true);
      t.value='${question}';
      t.dispatchEvent(evt)
    }
    setTimeout(() => {
        document.getElementsByClassName('button-right-inner')[0].click();
      }, 200)
    `)
};
chatglmController.prototype.getQuestion = function(text,prompt = this.config.currentPrompt) {
  let question = this.prompts[prompt].context.replace('{{context}}',text).replace('{{knowledge}}',this.knowledge)
  return question
  
};
chatglmController.prototype.setToolbar = async function(state) {
  this.toolbarOn = state
  // this.searchButton.hidden = !this.toolbarOn
  this.homeButton.hidden = !this.toolbarOn
  // this.screenButton.hidden = !this.toolbarOn
  this.engineButton.hidden = !this.toolbarOn

}

chatglmController.prototype.runJavaScript = async function(script,delay) {
  if(!this.webview || !this.webview.window)return;
  return new Promise((resolve, reject) => {
    if (delay) {
      this.viewTimer = NSTimer.scheduledTimerWithTimeInterval(delay, true, () => {
        this.webview.evaluateJavaScript(script,(result) => {resolve(result)});
      })
    }else{
      this.webview.evaluateJavaScript(script,(result) => {resolve(result)});
    }
  })
};

chatglmController.prototype.updateBilibiliOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.runJavaScript(`document.getElementsByClassName("recommended-swipe grid-anchor")[0].style.display = "none";`,0.5)
  this.shouldCopy = false
  this.shouldComment = false
};

chatglmController.prototype.updateBilibiliPCOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.runJavaScript(`document.getElementById("biliMainHeader").style.display = "none";`,1)
  this.shouldCopy = false
  this.shouldComment = false
};

chatglmController.prototype.updateThesaurusOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.viewTimer = NSTimer.scheduledTimerWithTimeInterval(2, true, () => {
    this.runJavaScript(getWebJS("updateThesaurusOffset"))
    this.viewTimer.invalidate();
  });
  this.shouldCopy = false
  this.shouldComment = false
};

chatglmController.prototype.getCurrentURL = async function() {
  if(!this.webview || !this.webview.window) return;
  let url = await this.runJavaScript(`window.location.href`)
  this.webview.url = url
  return url
};
chatglmController.prototype.getSelectedTextInWebview = async function() {
  let ret = await this.runJavaScript(`
      function getCurrentSelect(){

      let selectionObj = null, rangeObj = null;
      let selectedText = "", selectedHtml = "";

      if(window.getSelection){
        selectionObj = window.getSelection();
        selectedText = selectionObj.toString();
      }
      return selectedText
    };
      getCurrentSelect()
    `)
  return ret
}

chatglmController.prototype.getTextInWebview = async function() {
  let ret = await this.runJavaScript(`
      function getSelectOrWholeText(){

      let selectionObj = null, rangeObj = null;
      let selectedText = "", selectedHtml = "";

      if(window.getSelection){
        selectionObj = window.getSelection();
        selectedText = selectionObj.toString();
        return selectedText === ""?document.body.innerText:selectedText
      }else{
        return document.body.innerText;
      }
    };
    getSelectOrWholeText()
    // document.body.innerHTML;
    `)
  // let text = getArticleContent(ret)
  // this.appInstance.showHUD(text,this.view.window,2)
  return ret
}

chatglmController.prototype.changeButtonOpacity = function(opacity) {
    this.toolbar.layer.opacity = opacity
    this.moveButton.layer.opacity = opacity
    this.maxButton.layer.opacity = opacity
    this.minButton.layer.opacity = opacity
    this.closeButton.layer.opacity = opacity
}
chatglmController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = hexColorAlpha("#9bb2d6",0.8);
    button.layer.cornerRadius = 8;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}

chatglmController.prototype.createButton = function (buttonName,targetAction,superview) {
    this[buttonName] = UIButton.buttonWithType(0);
    this[buttonName].autoresizingMask = (1 << 0 | 1 << 3);
    this[buttonName].setTitleColorForState(UIColor.whiteColor(),0);
    this[buttonName].setTitleColorForState(this.highlightColor, 1);
    this[buttonName].backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this[buttonName].layer.cornerRadius = 8;
    this[buttonName].layer.masksToBounds = true;
    this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);

    if (targetAction) {
      this[buttonName].addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    if (superview) {
      this[superview].addSubview(this[buttonName])
    }else{
      this.view.addSubview(this[buttonName]);
    }
}

chatglmController.prototype.settingViewLayout = function (){
    let viewFrame = this.view.bounds
    let width = viewFrame.width
    let height = viewFrame.height
    this.settingView.frame = {x:1,y:20,width:width-2,height:height-50}
    this.configView.frame = genFrame(0,40,width-2,height-60)
    this.knowledgeView.frame = genFrame(0,40,width-2,height-60)
    this.autoActionView.frame = genFrame(0,40,width-2,height-60)
    this.advanceView.frame = genFrame(0,40,width-2,height-60)
    this.donationView.frame = genFrame(0,60,width-2,height-80)
    let imageWidth = Math.min(width-22,height-120)
    this.QRCode.frame = {x:10,y:0,width:imageWidth,height:imageWidth}


    this.orderButton.frame = genFrame(10,15,width-20,35)

    this.apiKeyButton.frame = genFrame(10,110,70,35)
    this.apiKeyInput.frame = genFrame(10,60,width-20,45)
    this.devButton.frame = genFrame(85,110,width-95,35)


    this.windowLocationButton.frame = genFrame(10,155,(width-25)*0.5,35)
    
    this.autoActionButton.frame = genFrame(10,15,(width-25)*0.5,35)
    this.delayButton.frame = genFrame((width-25)*0.5+15,15,(width-25)*0.5,35)
    this.onSelectionButton.frame = genFrame(10,60,(width-25)*0.5,35)
    this.onWebModeButton.frame = genFrame((width-25)*0.5+15,60,(width-25)*0.5,35)
    this.onNewExcerptButton.frame = genFrame(10,105,(width-20),35)
    this.onNoteButton.frame = genFrame(10,240,(width-20),35)
    this.ignoreButton.frame = genFrame(10,370,(width-20),35)


    this.contextInput.frame = {x:85,y:215,width:width-95,height:height-315}
    this.knowledgeInput.frame = {x:10,y:15,width:width-20,height:height-150}
    this.saveKnowledgeButton.frame = {x:10,y:height-130,width:width-20,height:30}
    this.titleInput.frame = {x:85,y:175,width:width-95,height:35}
    this.uploadButton.frame = {x:10,y:height-130,width:70,height:30}
    this.scrollview.frame = {x:10,y:15,width:width-20,height:150}
    this.scrollview.contentSize = {width:width-20,height:height};
    this.newEntryButton.frame = {x:width-45,y:135,width:30,height:25}
    this.configReset.frame = {x:width-110,y:135,width:60,height:25}
    this.deleteButton.frame = {x:width-175,y:135,width:60,height:25}
    this.titleButton.frame = {x:10,y:175,width:70,height:35}
    this.contextButton.frame = {x:10,y:215,width:70,height:35}

    let initX = 10
    let initY = 145

    for (let index = 0; index < 32; index++) {
      if (index == 8) {
        initX = 10
        initY = 190
      }
      if (index == 16) {
        initX = 10
        initY = 280
      }
      if (index == 24) {
        initX = 10
        initY = 325
      }
      this["ColorButton"+index].frame = genFrame(initX,initY,40,40)
      this["ColorButton"+index].setTitleForState(this.config.colorConfig[index]?"✓":"✖️",0)
      initX = initX+45
    }


    let settingFrame = this.settingView.bounds
    settingFrame.x = 5
    settingFrame.y = 5
    settingFrame.height = 40
    settingFrame.width = settingFrame.width-10
    this.tabView.frame = settingFrame
    settingFrame.width = 75
    settingFrame.y = 10
    settingFrame.x = 10
    settingFrame.height = 30
    this.configButton.frame = settingFrame
    settingFrame.x = 90
    settingFrame.width = 90
    this.knowledgeButton.frame = settingFrame
    settingFrame.x = 185
    settingFrame.width = 60
    this.actionButton.frame = settingFrame
    settingFrame.x = 250
    settingFrame.width = 80
    this.advancedButton.frame = settingFrame
    settingFrame.x = 335
    settingFrame.width = 80
    this.donationButton.frame = settingFrame
    this.donationButton.hidden = width<450
    settingFrame.x = width - 45
    settingFrame.width = 30
    this.closeConfig.frame = settingFrame
}

chatglmController.prototype.createSettingView = function (){
  this.creatView("settingView","view","#ffffff",1.0)
  this.settingView.hidden = true
  this.creatView("tabView","settingView")
  this.creatView("configView","settingView","#9bb2d6",0.0)

  this.creatView("knowledgeView","settingView","#9bb2d6",0.0)
  this.knowledgeView.hidden = true

  this.creatView("autoActionView","settingView","#9bb2d6",0.0)
  this.autoActionView.hidden = true

  this.creatView("advanceView","settingView","#9bb2d6",0.0)
  this.advanceView.hidden = true

  this.creatView("donationView","settingView","#9bb2d6",0.0)
  this.donationView.hidden = true

  this.QRCode = UIImageView.new()
  this.QRCode.image = this.QRCodeImage
  this.donationView.addSubview(this.QRCode)


  this.createButton("configButton","configButtonTapped:","settingView")
  this.configButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.configButton.layer.opacity = 1.0
  this.configButton.setTitleForState("Prompts",0)

  this.createButton("knowledgeButton","knowledgeButtonTapped:","settingView")
  // this.knowledgeButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.knowledgeButton.layer.opacity = 1.0
  this.knowledgeButton.setTitleForState("Knowledge",0)

  this.createButton("actionButton","actionButtonTapped:","settingView")
  // this.actionButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.actionButton.layer.opacity = 1.0
  this.actionButton.setTitleForState("Action",0)

  this.createButton("advancedButton","advancedButtonTapped:","settingView")
  // this.advancedButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.advancedButton.layer.opacity = 1.0
  this.advancedButton.setTitleForState("Advanced",0)

  this.createButton("donationButton","donationButtonTapped:","settingView")
  // this.donationButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.donationButton.layer.opacity = 1.0
  this.donationButton.setTitleForState("Donation",0)

  this.createButton("closeConfig","closeConfigTapped:","settingView")
  this.closeConfig.setImageForState(this.stopImage,0)
  this.closeConfig.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0)

  this.createButton("orderButton","changeSearchOrder:","advanceView")
  this.orderButton.layer.opacity = 1.0
  this.orderButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.orderButton.setTitleForState(getOrderText(this.searchOrder),0)

  this.createButton("apiKeyButton","pasteApiKey:","advanceView")
  this.apiKeyButton.layer.opacity = 1.0
  this.apiKeyButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.apiKeyButton.setTitleForState("Paste",0)
  this.createButton("devButton","openDev:","advanceView")
  this.devButton.layer.opacity = 1.0
  this.devButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.devButton.setTitleForState("open.bigmodel.cn",0)

  this.createButton("windowLocationButton","toggleWindowLocation:","advanceView")
  this.windowLocationButton.layer.opacity = 1.0
  this.windowLocationButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  let locInd = this.config.notifyLoc
    switch (locInd) {
      case 0:
        this.windowLocationButton.setTitleForState("Notification: Left",0)
        break;
      case 1:
        this.windowLocationButton.setTitleForState("Notification: Right",0)
        break;
      default:
        break;
    }



  this.createButton("autoActionButton","toggleAutoAction:","autoActionView")
  this.createButton("onSelectionButton","toggleOnSelection:","autoActionView")
  this.createButton("onNoteButton","toggleOnNote:","autoActionView")
  this.createButton("onNewExcerptButton","toggleOnNewExcerpt:","autoActionView")
  this.createButton("onWebModeButton","toggleOnWebMode:","autoActionView")
  this.createButton("ignoreButton","toggleIgnoreShortText:","autoActionView")
  this.ignoreButton.setTitleForState("Ignore short text: "+(this.config.ignoreShortText?"✅":"🚫"),0)
  if (this.config.ignoreShortText) {
    this.ignoreButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  }else{
    this.ignoreButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
  }
  this.autoActionButton.layer.opacity = 1.0
  if (this.config.autoAction) {
    this.autoActionButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    this.autoActionButton.setTitleForState("Auto Action: ✅",0)
    this.onSelectionButton.hidden = false
    this.onNewExcerptButton.hidden = false
    this.onNoteButton.hidden = false
    this.onWebModeButton.hidden = false
    this.ignoreButton.hidden = false

  }else{
    this.autoActionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this.autoActionButton.setTitleForState("Auto Action: ❌",0)
    this.onSelectionButton.hidden = true
    this.onNewExcerptButton.hidden = true
    this.onNoteButton.hidden = true
    this.onWebModeButton.hidden = true
    this.ignoreButton.hidden = true

  }

  if (this.config.onSelection) {
    this.onSelectionButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    this.onSelectionButton.setTitleForState("On Selection: ✅",0)
  }else{
    this.onSelectionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this.onSelectionButton.setTitleForState("On Selection: ❌",0)
  }

  if (this.config.onNote) {
    this.onNoteButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    this.onNoteButton.setTitleForState("On Note: ✅",0)
  }else{
    this.onNoteButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this.onNoteButton.setTitleForState("On Note: ❌",0)
  }

  if (this.config.onNewExcerpt) {
    this.onNewExcerptButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    this.onNewExcerptButton.setTitleForState("On New Excerpt: ✅",0)
  }else{
    this.onNewExcerptButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this.onNewExcerptButton.setTitleForState("On New Excerpt: ❌",0)
  }

  if (this.config.onWebMode) {
    this.onWebModeButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    this.onWebModeButton.setTitleForState("On Web Mode: ✅",0)
  }else{
    this.onWebModeButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this.onWebModeButton.setTitleForState("On Web Mode: ❌",0)
  }

  this.createButton("delayButton","changeDelay:","autoActionView")
  this.delayButton.setTitleForState("Delay: "+this.config.delay+"s",0)
  this.delayButton.backgroundColor = hexColorAlpha("#457bd3",0.8)


  this.creatTextView("apiKeyInput","advanceView")
  let apikey = this.config.apikey
  if (this.apikey === "") {
    apikey = `Input your api key here`
  }
  this.apiKeyInput.text = apikey
  this.apiKeyInput.bounces = true
  this.apiKeyInput.editable = false

  this.scrollview = UIScrollView.new()
  this.configView.addSubview(this.scrollview)
  this.scrollview.hidden = false
  this.scrollview.delegate = this
  this.scrollview.bounces = true
  this.scrollview.alwaysBounceVertical = true
  this.scrollview.layer.cornerRadius = 8
  this.scrollview.backgroundColor = hexColorAlpha("#c0bfbf",0.8)

  this.creatTextView("contextInput","configView")

  this.creatTextView("titleInput","configView")
  this.creatTextView("knowledgeInput","knowledgeView")
  this.knowledgeInput.text = getLocalDataByKeyDefault('MNChatglm_knowledge',"")
  // let entries           = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entries');
  let text  = this.prompts[this.config.currentPrompt]
  this.contextInput.text = text.context
  this.titleInput.text = text.title
  this.titleInput.contentInset = {top: 0,left: 0,bottom: 0,right: 0}
  this.titleInput.textContainerInset = {top: 0,left: 0,bottom: 0,right: 0}
  this.createButton("configReset","resetConfig:","configView")
  this.configReset.layer.opacity = 1.0
  this.configReset.setTitleForState("Reset",0)

  this.createButton("uploadButton","configSaveTapped:","configView")
  this.uploadButton.layer.opacity = 1.0
  this.uploadButton.setTitleForState("Save",0)
  this.createButton("deleteButton","configDeleteTapped:","configView")
  this.deleteButton.layer.opacity = 1.0
  this.deleteButton.setTitleForState("Delete",0)
  this.createButton("newEntryButton","configAddTapped:","configView")
  this.newEntryButton.layer.opacity = 1.0
  this.newEntryButton.setTitleForState("➕",0)
  this.createButton("titleButton",undefined,"configView")
  this.titleButton.layer.opacity = 1.0
  this.titleButton.setTitleForState("Title:",0)
  this.titleButton.backgroundColor = hexColorAlpha("#457bd3",0.8)

  this.createButton("contextButton",undefined,"configView")
  this.contextButton.layer.opacity = 1.0
  this.contextButton.setTitleForState("Context:",0)
  this.contextButton.backgroundColor = hexColorAlpha("#457bd3",0.8)

  this.createButton("saveKnowledgeButton","saveKnowledgeButtonTapped","knowledgeView")
  this.saveKnowledgeButton.layer.opacity = 1.0
  this.saveKnowledgeButton.setTitleForState("Save",0)
  this.saveKnowledgeButton.backgroundColor = hexColorAlpha("#457bd3",0.8)

  let color = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9fdc"]
    for (let index = 0; index < 32; index++) {
      this["ColorButton"+index]   = UIButton.buttonWithType(0);
      this["ColorButton"+index].index = index
      this["ColorButton"+index].hidden = !this.config.autoAction
      if (index > 15) {
        this.setColorButtonLayout(this["ColorButton"+index],"toggleColorConfig:",color[index-16])
      }else{
        this.setColorButtonLayout(this["ColorButton"+index],"toggleColorConfig:",color[index])
      }
      // self["ColorButton"+index].setTitleForState(self.imagePattern[index]===self.textPattern[index]?` ${self.imagePattern[index]} `:"-1",0) 
    }
}

chatglmController.prototype.setButtonText = function (names,highlight) {
    this.words = names

    // this.appInstance.showHUD(names,this.view.window,5)
    // UIPasteboard.generalPasteboard().string = this.configMode

    names.map((word,index)=>{
      if (!this["nameButton"+index]) {
        this.createButton("nameButton"+index,"toggleSelected:","scrollview")
        // this["nameButton"+index].index = index
        this["nameButton"+index].titleLabel.font = UIFont.systemFontOfSize(16);
      }
      this["nameButton"+index].hidden = false
      // this["nameButton"+index].tag = 
      // if (!this.entries[word]) {
        
      // }
      // showHUD(this.prompts[word].title)
      this["nameButton"+index].setTitleForState(this.prompts[word].title,0) 
      this["nameButton"+index].id = word

      if (word === highlight) {
        this["nameButton"+index].backgroundColor = hexColorAlpha("#457bd3",0.8)
        this["nameButton"+index].isSelected = true
      }else{
        this["nameButton"+index].backgroundColor = hexColorAlpha("#9bb2d6",0.8);
        this["nameButton"+index].isSelected = false
      }
      // this["nameButton"+index].titleEdgeInsets = {top:0,left:-100,bottom:0,right:-50}
      // this["nameButton"+index].setTitleForState(this.imagePattern[index]===this.textPattern[index]?` ${this.imagePattern[index]} `:"-1",0) 
    })
    this.refreshLayout()
}
chatglmController.prototype.setTextview = function (name) {
      // let entries           = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entries');
      let text  = this.prompts[name]
      this.titleInput.text= text.title
      this.contextInput.text = text.context

}
chatglmController.prototype.setSplitScreenFrame = function (mode) {  
  let studyFrame = this.appInstance.studyController(this.view.window).view.bounds
  let height = studyFrame.height;
  let width = studyFrame.width;
  let splitLine = getSplitLine()
  switch (mode) {
  case "left":
    this.view.frame = genFrame(40,0,splitLine-40,height)
    break;
  case "left13":
    this.view.frame = genFrame(40,0,width/3.+40,height)
    break;
  case "right":
    this.view.frame = genFrame(splitLine,0,width-splitLine-40,height)
    break;
  case "right13":
    this.view.frame = genFrame(width*2/3.-40,0,width/3.,height)
    break;
  case "full":
    this.view.frame = genFrame(40,0,width-80,height)
    break;
  default:
    break;
  }
  this.currentFrame = this.view.frame
}
chatglmController.prototype.toMinimode = function (frame) {
  this.miniMode = true 
  this.dynamic = false    
  this.lastFrame = this.view.frame 
  this.webview.hidden = true
  if (this.settingView) {
    this.settingView.hidden = true
  }
  this.currentFrame  = this.view.frame
  this.hideAllButton()
  this.view.layer.borderWidth = 3
  this.view.layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.frame = frame
    this.currentFrame  = this.view.frame
  },
  ()=>{
    this.moveButton.frame = genFrame(0,0,40,40)
    this.moveButton.hidden = false
  })
}
chatglmController.prototype.refreshLayout = function () {
  if (!this.settingView) {return}
  if (!this.configView.hidden) {
    var viewFrame = this.scrollview.bounds;
    var xLeft     = 0
    let initX = 10
    let initY = 10
    let initL = 0
    this.locs = [];
    // showHUD("refresh")
    this.words.map((word,index)=>{
      let title = this.prompts[word].title
      let width = strCode(title.replaceAll(" ",""))*9+15
      if (xLeft+initX+width > viewFrame.width-10) {
        initX = 10
        initY = initY+40
        initL = initL+1
      }
      this["nameButton"+index].frame = {  x: xLeft+initX,  y: initY,  width: width,  height: 30,};
      this.locs.push({
        x:xLeft+initX,
        y:initY,
        l:initL,
        i:index
      })
      initX = initX+width+10
    })
    if (this.lastLength && this.lastLength>this.words.length) {
      // Application.sharedInstance().showHUD("should clear", this.view.window, 2);
      for (let index = this.words.length; index < this.lastLength; index++) {
        this["nameButton"+index].hidden = true
      }
    }
    this.lastLength = this.words.length
    // Application.sharedInstance().showHUD(initY, this.view.window, 2);
    this.scrollview.contentSize= {width:viewFrame.width,height:initY+40}
  
  }
}

chatglmController.prototype.hideAllButton = function (frame) {
  this.moveButton.hidden = true
  this.closeButton.hidden = true
  this.maxButton.hidden = true
  this.minButton.hidden = true
  this.toolbar.hidden = true
}
chatglmController.prototype.showAllButton = function (frame) {
  this.moveButton.hidden = false
  this.closeButton.hidden = false
  this.maxButton.hidden = false
  this.minButton.hidden = false
  this.toolbar.hidden = false
}
chatglmController.prototype.show = function (frame) {
  studyController().view.bringSubviewToFront(this.view)
  studyController().view.bringSubviewToFront(this.addonBar)
  let preFrame = this.currentFrame
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0.2
  if (frame) {
    this.view.frame = frame
    this.currentFrame = frame
  }
  this.view.hidden = false
  if (this.miniMode) {
    this.webview.layer.borderWidth = 0
  }else{
    this.webview.layer.borderWidth = 3
  }
  this.miniMode = false
  this.webview.hidden = false
  this.hideAllButton()
  if (this.toolbarOn) {
    this.engineButton.hidden = false
  }

  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.layer.opacity = preOpacity
    this.view.frame = preFrame
    this.currentFrame = preFrame
  },
  ()=>{
    this.webview.layer.borderWidth = 0
    this.view.layer.borderWidth = 0
    this.webview.hidden = false
    this.showAllButton()
  })
}
chatglmController.prototype.hide = function (frame) {
  studyController().view.bringSubviewToFront(this.addonBar)
  let preFrame = this.view.frame
  let preOpacity = this.view.layer.opacity
  let preCustom = this.custom
  // let preFrame = this.view.frame
  if (this.settingView) {
    this.settingView.hidden = true
  }
  this.webview.hidden = false
  this.hideAllButton()
  this.custom = false
  if (frame) {
    this.webview.layer.borderWidth = 3
  }
  UIView.animateWithDurationAnimationsCompletion(0.25,()=>{
    this.view.layer.opacity = 0.2
    if (frame) {
      this.view.frame = frame
      this.currentFrame = frame
    }
    // this.view.frame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
    // this.currentFrame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
  },
  ()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
    this.view.frame = preFrame
    this.currentFrame = preFrame
    this.webview.layer.borderWidth = 0
    this.custom = preCustom
    // this.view.frame = preFrame
    // this.currentFrame = preFrame
  })
}

chatglmController.prototype.creatView = function (viewName,superview="view",color="#9bb2d6",alpha=0.8) {
  this[viewName] = UIView.new()
  this[viewName].backgroundColor = hexColorAlpha(color,alpha)
  this[viewName].layer.cornerRadius = 12
  this[superview].addSubview(this[viewName])
}

chatglmController.prototype.creatTextView = function (viewName,superview="view",color="#c0bfbf",alpha=0.8) {
  this[viewName] = UITextView.new()
  this[viewName].font = UIFont.systemFontOfSize(15);
  this[viewName].layer.cornerRadius = 8
  this[viewName].backgroundColor = hexColorAlpha(color,alpha)
  this[viewName].textColor = UIColor.blackColor()
  this[viewName].delegate = this
  this[viewName].bounces = true
  this[superview].addSubview(this[viewName])
}


chatglmController.prototype.setColorButtonLayout = function (button,targetAction,color) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.blackColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString(color).colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    button.layer.borderWidth = 2
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.autoActionView.addSubview(button);
}